#include <QtGui>
#include <sys/stat.h>
#include <sys/types.h>

#include "buhamain.h"
#include "journal.h"
#include "zahlungen.h"
#include "kontenplan.h"
#include "einzelkto.h"
#include "gliederung.h"
#include "mitglieder.h"
#include "setup.h"
#include "midimport.h"
#include "lieferant.h"
#include "ktodruck.h"
#include "journexport.h"
#include "spendenexport.h"
#include "spendenparam.h"
#include "akkredlist.h"
#include "textbaustein.h"
#include "zahlerst.h"
#include "zahlmail.h"
#include "zahldtaus.h"
#include "zahlbearb.h"
#include "zahlbrief.h"
#include "utils.h"
#include "save.h"
#include "spende.h"
#include "zuwenddruck.h"

extern QImage wLogo;

BuhaMain::BuhaMain(QWidget *parent) : QDialog(parent)
{
  QMenuBar *mbMain = new QMenuBar(this);
  QMenu    *wMenu;
  QAction  *wAction;

  wMenu=mbMain->addMenu("&Buchungen");
  wAction=new QAction("&Journal",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pJournal()));
  wMenu->addAction(wAction);
  wAction=new QAction("B&ank/Kasse",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pZahlungen()));
  wMenu->addAction(wAction);
  wAction=new QAction("Einzel&konten",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pEinzelKto()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Ende",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(reject()));
  wMenu->addAction(wAction);

  wMenu=mbMain->addMenu("&Stammdaten");
  wAction=new QAction("&Kontenplan",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pKtoPlan()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Mitglieder",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pMitglieder()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Lieferanten",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pLieferant()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Gliederungen",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pGliederung()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Textbausteine",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pTextbaustein()));
  wMenu->addAction(wAction);

  wMenu=mbMain->addMenu("&Drucke/Datenaustausch");
  wAction=new QAction("&Kontendruck",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pKtoDruck()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Journalexport",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pJournExport()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Spendenbuch Export",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pSpendenExport()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Akkreditierungsliste",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pAkkredListe()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Mitgliederimport",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pMIDImport()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Zuwendungsbesttigungen",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pZuwend()));
  wMenu->addAction(wAction);

  if (UtilBeitragAb()!=2)
  {
    wMenu=mbMain->addMenu("&Zahlungen");
    wAction=new QAction("&Erstellen",this);
    connect(wAction,SIGNAL(triggered()),this,SLOT(pZahlErst()));
    wMenu->addAction(wAction);
    menZahlBearb=wMenu->addMenu("&Bearbeiten");
    actZBearbRech=new QAction("&Vorkasse",this);
    connect(actZBearbRech,SIGNAL(triggered()),this,SLOT(pZahlBearb()));
    menZahlBearb->addAction(actZBearbRech);
    actZBearbRechNeu=new QAction("Vorkasse &Neumitglieder",this);
    connect(actZBearbRechNeu,SIGNAL(triggered()),this,SLOT(pZahlBearb()));
    menZahlBearb->addAction(actZBearbRechNeu);
    actZBearbLast=new QAction("&Lastschrifthinweis",this);
    connect(actZBearbLast,SIGNAL(triggered()),this,SLOT(pZahlBearb()));
    menZahlBearb->addAction(actZBearbLast);
    actZBearbLastNeu=new QAction("Lastschrifthinweis N&eumitglieder",this);
    connect(actZBearbLastNeu,SIGNAL(triggered()),this,SLOT(pZahlBearb()));
    menZahlBearb->addAction(actZBearbLastNeu);
    actZBearbDtaus=new QAction("&DTAUS-Datei",this);
    connect(actZBearbDtaus,SIGNAL(triggered()),this,SLOT(pZahlBearb()));
    menZahlBearb->addAction(actZBearbDtaus);
    actZBearbPlatz=new QAction("&Geplatzte Lastschrift",this);
    connect(actZBearbPlatz,SIGNAL(triggered()),this,SLOT(pZahlBearb()));
    menZahlBearb->addAction(actZBearbPlatz);
    actZBearbMahn1=new QAction("&1. Mahnung",this);
    connect(actZBearbMahn1,SIGNAL(triggered()),this,SLOT(pZahlBearb()));
    menZahlBearb->addAction(actZBearbMahn1);
    actZBearbMahn2=new QAction("&2. Mahnung",this);
    connect(actZBearbMahn2,SIGNAL(triggered()),this,SLOT(pZahlBearb()));
    menZahlBearb->addAction(actZBearbMahn2);
    actZBearbMahn3=new QAction("&3. Mahnung",this);
    connect(actZBearbMahn3,SIGNAL(triggered()),this,SLOT(pZahlBearb()));
    menZahlBearb->addAction(actZBearbMahn3);

    menZahlDo=wMenu->addMenu("&Durchfhren");
    actZDoMail=new QAction("&Emails",this);
    connect(actZDoMail,SIGNAL(triggered()),this,SLOT(pZahlMail()));
    menZahlDo->addAction(actZDoMail);
    actZDoBrief=new QAction("&Briefe",this);
    connect(actZDoBrief,SIGNAL(triggered()),this,SLOT(pZahlBrief()));
    menZahlDo->addAction(actZDoBrief);
    actZDoDtaus=new QAction("&Dtaus Datei",this);
    connect(actZDoDtaus,SIGNAL(triggered()),this,SLOT(pZahlDtaus()));
    menZahlDo->addAction(actZDoDtaus);
  
    actZAbschl=new QAction("&Abschliessen",this);
    connect(actZAbschl,SIGNAL(triggered()),this,SLOT(pZahlAbschl()));
    wMenu->addAction(actZAbschl);
    pSetZahlMenu();
  }

  wMenu=mbMain->addMenu("Dienst&programme");
  wAction=new QAction("&BLZ-Datei lesen",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pBlzImp()));
  wMenu->addAction(wAction);
  wAction=new QAction("S&pendenparameter",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pSpendenParam()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Setup",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pSetup()));
  wMenu->addAction(wAction);
  wAction=new QAction("&Datensicherung",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pSave()));
  wMenu->addAction(wAction);
  wAction=new QAction("Daten &Wiederherstellen",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pRestore()));
  wMenu->addAction(wAction);
  wAction=new QAction("Neue Programm&version",this);
  connect(wAction,SIGNAL(triggered()),this,SLOT(pUpdate()));
  wMenu->addAction(wAction);

  wSizeX=mbMain->sizeHint().width();
  wMenuHeight=mbMain->sizeHint().height();
  if (wSizeX<wLogo.width())
     wSizeX=wLogo.width();
  wSizeY=wMenuHeight+2*wLogo.height();
  setFixedSize(wSizeX,wSizeY);
  return;
}

void BuhaMain::paintEvent(QPaintEvent *event)
{
  QFont wFont;
  int   w,y,h;

  QPainter *wPainter = new QPainter(this);
  wPainter->fillRect(0,wMenuHeight,wSizeX,wSizeY-wMenuHeight,Qt::white);
  h=wLogo.height();
  y=(wSizeY-wMenuHeight-h)/2+wMenuHeight;
  wPainter->drawImage((wSizeX-wLogo.width())/2,y,wLogo);
  wFont.setFamily("Helvetica");
  wFont.setWeight(QFont::Bold);
  wFont.setPointSize(12);
  wPainter->setFont(wFont);
  QFontMetrics wFontMetrics = wPainter->fontMetrics();
  w=wFontMetrics.width(UtilSelbst());
  wPainter->drawText((wSizeX-w)/2,y+h+15,UtilSelbst());
  wPainter->end();
}

void BuhaMain::pKtoPlan()
{
  Kontenplan pDiag;
  pDiag.exec();
}

void BuhaMain::pJournal()
{
  Journal pDiag;
  pDiag.exec();
}

void BuhaMain::pEinzelKto()
{
  EinzelKto pDiag;
  pDiag.exec();
}

void BuhaMain::pGliederung()
{
  Gliederung pDiag;
  pDiag.exec();
}

void BuhaMain::pMitglieder()
{
  Mitglieder pDiag(false);
  pDiag.exec();
}

void BuhaMain::pLieferant()
{
  Lieferant pDiag;
  pDiag.exec();
}

void BuhaMain::pSetup()
{
  Setup pDiag;
  pDiag.exec();
}

void BuhaMain::pZahlungen()
{
  Zahlungen pDiag;
  pDiag.exec();
}

void BuhaMain::pMIDImport()
{
  MIDImport pDiag;
  pDiag.exec();
}

void BuhaMain::pKtoDruck()
{
  Kontendruck pDiag;
  pDiag.exec();
}

void BuhaMain::pJournExport()
{
  JournalExport pDiag;
  pDiag.exec();
}

void BuhaMain::pSpendenExport()
{
  SpendenExport pDiag;
  pDiag.exec();
}

void BuhaMain::pSpendenParam()
{
  SpendenParam pDiag;
  pDiag.exec();
}

void BuhaMain::pAkkredListe()
{
  AkkredListe pDiag;
  pDiag.exec();
}

void BuhaMain::pTextbaustein()
{
  Textbaustein pDiag;
  pDiag.exec();
}

void BuhaMain::pZahlErst()
{
  QSqlQuery query;
  ZahlungErst pDiag;

  query.exec("SELECT wert FROM parameter WHERE key='Status/Zahlungen'");
  if (query.next())
  {
    query.finish();
    if (QMessageBox::question(this,"Buha",
         "Erstellte Zahlungen wurden noch nicht abgeschlossen. Durch ein erneutes Erstellen gehen diese Daten verloren, Doppelzahlungen sind nicht ausgeschlossen.\nSollen die Zahlungen neu erstellt werden?",
          QMessageBox::Yes|QMessageBox::No)            != QMessageBox::Yes)
       return;
  }
  pDiag.exec();
  pSetZahlMenu();
}

void BuhaMain::pZahlBrief()
{
  ZahlungBrief pDiag;
  pDiag.exec();
  pSetZahlMenu();
}

void BuhaMain::pZahlMail()
{
  ZahlungMail pDiag;
  pDiag.exec();
  pSetZahlMenu();
}

void BuhaMain::pZahlDtaus()
{
  ZahlungDtaus pDiag;
  pDiag.exec();
  pSetZahlMenu();
}

void BuhaMain::pZuwend()
{
  Zuwenddruck pDiag;
  pDiag.exec();
}

void BuhaMain::pZahlBearb()
{
  QAction *wSender = (QAction*)sender();
  QString wArt;

  if      (wSender==actZBearbRech)    wArt="R";
  else if (wSender==actZBearbRechNeu) wArt="r";
  else if (wSender==actZBearbLast)    wArt="L";
  else if (wSender==actZBearbLastNeu) wArt="l";
  else if (wSender==actZBearbDtaus)   wArt="D";
  else if (wSender==actZBearbPlatz)   wArt="G";
  else if (wSender==actZBearbMahn1)   wArt="1";
  else if (wSender==actZBearbMahn2)   wArt="2";
  else if (wSender==actZBearbMahn3)   wArt="3";
  else return;

  ZahlungBearb pDiag(wArt);
  pDiag.exec();
}

void BuhaMain::pSave()
{
  SaveSave();
}

void BuhaMain::pRestore()
{
  SaveRestore();
}

void BuhaMain::pSetZahlMenu()
{
  QSqlQuery query;
  QString   s;
  bool fErst,fRech,fRechNeu,fLast,fLastNeu,fDtaus,fPlatz,fMahn1,fMahn2,fMahn3;
  bool fBrief,fMail,fBriefOk,fMailOk,fDtausOk;

  if (UtilBeitragAb()==2) return;
  query.exec("SELECT wert FROM parameter WHERE key='Status/Zahlungen'");
  if (query.next())
  {
     s=query.value(0).toString();
     query.finish();
  }
  else
     s="";
  fErst=fRech=fRechNeu=fLast=fLastNeu=fDtaus=fPlatz=fMahn1=fMahn2=fMahn3=false;
  fBrief=fMail=false;
  fBriefOk=fMailOk=fDtausOk=true;
  if (s.length()> 0 && (s[ 0]=='J' || s[ 0]=='D')) fErst=fDtaus=true;
  if (s.length()> 1 && (s[ 1]=='J' || s[ 1]=='D')) fErst=fMail= fRech=true;
  if (s.length()> 2 && (s[ 2]=='J' || s[ 2]=='D')) fErst=fBrief=fRech=true;
  if (s.length()> 3 && (s[ 3]=='J' || s[ 3]=='D')) fErst=fMail= fRechNeu=true;
  if (s.length()> 4 && (s[ 4]=='J' || s[ 4]=='D')) fErst=fBrief=fRechNeu=true;
  if (s.length()> 5 && (s[ 5]=='J' || s[ 5]=='D')) fErst=fMail= fLast=true;
  if (s.length()> 6 && (s[ 6]=='J' || s[ 6]=='D')) fErst=fBrief=fLast=true;
  if (s.length()> 7 && (s[ 7]=='J' || s[ 7]=='D')) fErst=fMail= fLastNeu=true;
  if (s.length()> 8 && (s[ 8]=='J' || s[ 8]=='D')) fErst=fBrief=fLastNeu=true;
  if (s.length()> 9 && (s[ 9]=='J' || s[ 9]=='D')) fErst=fMail= fPlatz=true;
  if (s.length()>10 && (s[10]=='J' || s[10]=='D')) fErst=fBrief=fPlatz=true;
  if (s.length()>11 && (s[11]=='J' || s[11]=='D')) fErst=fMail= fMahn1=true;
  if (s.length()>12 && (s[12]=='J' || s[12]=='D')) fErst=fBrief=fMahn1=true;
  if (s.length()>13 && (s[13]=='J' || s[13]=='D')) fErst=fMail= fMahn2=true;
  if (s.length()>14 && (s[14]=='J' || s[14]=='D')) fErst=fBrief=fMahn2=true;
  if (s.length()>15 && (s[15]=='J' || s[15]=='D')) fErst=fMail= fMahn3=true;
  if (s.length()>16 && (s[16]=='J' || s[16]=='D')) fErst=fBrief=fMahn3=true;

  if (s.length()> 0 && s[ 0]=='J') fDtausOk=false;
  if (s.length()> 1 && s[ 1]=='J') fMailOk =false;
  if (s.length()> 2 && s[ 2]=='J') fBriefOk=false;
  if (s.length()> 3 && s[ 3]=='J') fMailOk =false;
  if (s.length()> 4 && s[ 4]=='J') fBriefOk=false;
  if (s.length()> 5 && s[ 5]=='J') fMailOk =false;
  if (s.length()> 6 && s[ 6]=='J') fBriefOk=false;
  if (s.length()> 7 && s[ 7]=='J') fMailOk =false;
  if (s.length()> 8 && s[ 8]=='J') fBriefOk=false;
  if (s.length()> 9 && s[ 9]=='J') fMailOk =false;
  if (s.length()>10 && s[10]=='J') fBriefOk=false;
  if (s.length()>11 && s[11]=='J') fMailOk =false;
  if (s.length()>12 && s[12]=='J') fBriefOk=false;
  if (s.length()>13 && s[13]=='J') fMailOk =false;
  if (s.length()>14 && s[14]=='J') fBriefOk=false;
  if (s.length()>15 && s[15]=='J') fMailOk =false;
  if (s.length()>16 && s[16]=='J') fBriefOk=false;

  menZahlBearb->setEnabled(fErst);
  menZahlDo->setEnabled(fErst);
  actZAbschl->setEnabled(fErst);

  actZBearbRech->setEnabled(fRech);
  actZBearbRechNeu->setEnabled(fRechNeu);
  actZBearbLast->setEnabled(fLast);
  actZBearbLastNeu->setEnabled(fLastNeu);
  actZBearbDtaus->setEnabled(fDtaus);
  actZBearbPlatz->setEnabled(fPlatz);
  actZBearbMahn1->setEnabled(fMahn1);
  actZBearbMahn2->setEnabled(fMahn2);
  actZBearbMahn3->setEnabled(fMahn3);

  actZDoMail->setEnabled(fMail);
  actZDoDtaus->setEnabled(fDtaus);

  if (fMail && fMailOk)   actZDoMail->setText("&Emails (ok)");
  else                    actZDoMail->setText("&Emails");
  if (fBrief && fBriefOk) actZDoBrief->setText("&Briefe (ok)");
  else                    actZDoBrief->setText("&Briefe");
  if (fDtaus && fDtausOk) actZDoDtaus->setText("&Dtaus Datei (ok)");
  else                    actZDoDtaus->setText("&Dtaus Datei");
}

void BuhaMain::pZahlAbschl()
{
  QSqlQuery query,query2;
  QString   sHeute;
  Spende    wSpende;
  QDate     dHeute,dBudat;
  QString   sKonto,sGKonto,sKost,sText;
  qint64    total,teilBetrag;
  int       i,n;

  if (QMessageBox::question(this,"Buha",
       "Alle durchgefhrten Zahlungen abschliessen?",
        QMessageBox::Yes|QMessageBox::No)            != QMessageBox::Yes)
     return;

  dHeute=QDate::currentDate();
  sHeute=dHeute.toString("yyyy-MM-dd");
  query.exec("SELECT mid,statusneu,art,bausteinm,bausteinb,cent from zahllauf WHERE done='J' ORDER BY mid");
  while(query.next())
  {
    query2.exec("UPDATE mitglied SET zahlstatus='" + query.value(1).toString() +
                "',statusdatum='" + sHeute + "' WHERE mid='" +
                query.value(0).toString() + "'");
    if (query.value(2).toString()=="D"       &&
        query.value(3).toString().length()>0 &&
        query.value(4).toString().length()>0   )
    {
      sKonto=query.value(3).toString();
      dBudat=query.value(4).toDate();
      total=query.value(5).toLongLong();
      wSpende.clear();
      wSpende.setParam(query.value(0).toInt(),'M',QDate(dHeute.year(),12,31));
      wSpende.aufteilung(false,-2,total,&teilBetrag,&sGKonto,&sText);
      wSpende.aufteilung(false,-1,total,&teilBetrag,&sGKonto,&sKost);
      n=UtilBuch(dBudat,0,sKost,"",sText,total,sKonto,sGKonto,"","");
      sKonto=sGKonto;
      for (i=0; i<10; i++)
      {
        wSpende.aufteilung(false,i,total,&teilBetrag,&sGKonto,&sKost);
        if (teilBetrag!=0 && sGKonto.length()>0)
        {
          UtilBuch(dBudat,0,sKost,"",sText,teilBetrag,sKonto,sGKonto,"","");
        }
      }
      wSpende.write(dBudat,n);
    }
  }
  query.exec("DELETE FROM zahllauf");
  query.exec("DELETE FROM parameter WHERE key='Status/Zahlungen'");
  pSetZahlMenu();
  QMessageBox::information(this,"Buha","Zahlungen sind abgeschlossen");
}

void BuhaMain::pBlzImp()
{
  QSqlQuery query;
  QFile     fBlz;
  QString   sName,sZeile;

  sName=QFileDialog::getOpenFileName(this,"Bankleitzahlendatei");
  if (sName.length()<1) return;
  fBlz.setFileName(sName);
  if (!fBlz.open(QIODevice::ReadOnly))
  {
    QMessageBox::critical(NULL,"Bankleitzahlendatei",fBlz.errorString());
    return;
  }
  QTextStream fText(&fBlz);
  fText.setCodec("ISO8859-1");
  QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
  query.exec("START TRANSACTION");
  query.exec("DELETE FROM blzdatei");
  while(!fText.atEnd())
  {
    sZeile=fText.readLine();
    if (sZeile.length()>151)
    {
      query.exec("INSERT INTO blzdatei (land,blz,name,pruefart,bic) VALUES ('D','" +
                 sZeile.mid(0,8) + "','" + sZeile.mid(107,27) + "','" +
                 sZeile.mid(150,2) + "','" + sZeile.mid(139,11) + "')");
    }
  }
  query.exec("COMMIT TRANSACTION");
  fBlz.close();
  QApplication::restoreOverrideCursor();
  QMessageBox::information(this,"BLZ Datei","Fertig");
}

void BuhaMain::pUpdate()
{
  QString sName,s,sAlt,sNeu;
  char    *sTempDir;
  int     r;

  sAlt=QCoreApplication::applicationFilePath();
  sName=QFileDialog::getOpenFileName(this,"Neue Programmversion");
  if (sName.length()<1) return;
  sTempDir=tempnam(NULL,"BUHA");
  if (sTempDir==NULL) return;
  r=mkdir(sTempDir,0700);
  s="cd ";
  s=s + sTempDir;
  s=s + "; cat ";
  s=s + sName;
  s=s + "| tar xf - .";
  system(s.toAscii().data());
  sNeu=sTempDir;
  sNeu=sNeu+"/buha";
  if (!QFile::exists(sNeu))
  {
    QMessageBox::critical(this,"Neue Programmversion","Ungltige Datei");
  }
  else
  {
    s="xterm -e \"sudo mv ";
    s=s + sAlt;
    s=s + " ";
    s=s + sAlt;
    s=s + ".bak; sudo cp ";
    s=s + sNeu;
    s=s + " ";
    s=s + sAlt;
    s=s + "; sudo chmod 755 ";
    s=s + sAlt;
    s=s + "; sudo chown root.root ";
    s=s + sAlt;
    s=s + "\"";
    system(s.toAscii().data());
    s="rm -r ";
    s=s+sTempDir;
    system(s.toAscii().data());
    QMessageBox::information(this,"Neue Programmverision","Programm ist aktualisiert. Bitte beenden und neu starten");
  }
  free(sTempDir);
}
