create table kontenplan
(
  konto     text,
  text      text,
  abgrart   char(1)
);
create unique index ktopl00 on kontenplan (konto);

create table journdat
(
  datum     date,
  lfd       integer,
  kost      varchar(20),
  beleg     varchar(20),
  extlfd    integer,
  butext    text,
  erfasst   datetime,
  art       char(1),
  beschluss text
);
create unique index journ00 on journdat (datum,lfd);
create        index journ01 on journdat (erfasst);

create table kgkto
(
  datum   date,
  lfd     integer,
  kg      integer,
  konto   text,
  cent    int64,
  abstimm integer
);
create unique index kg00 on kgkto (datum,lfd,kg);
create        index kg01 on kgkto (konto,datum,lfd);

create table verband
(
  namekurz     text,
  gegruendet   date,
  ebene        int,
  teilvon      text,
  bukto        varchar(10),
  vorsitzname  text,
  vorsitzmail  text,
  vorsitztel   text,
  vorsitzfax   text,
  gensekname   text,
  gensekmail   text,
  gensektel    text,
  gensekfax    text,
  schatzname   text,
  schatzmail   text,
  schatztel    text,
  schatzfax    text
);
create unique index vb00 on verband (namekurz);
create        index vb01 on verband (bukto);
create        index vb02 on verband (ebene,teilvon);
create        index vb03 on verband (ebene,namekurz);

create table adresse
(
  art          char,
  key          text,
  suchname     text,
  name1        text,
  name2        text,
  strasse      text,
  plz          text,
  ort          text,
  land         text,
  mail         text
);
create unique index adr00 on adresse (art,key);
create        index adr01 on adresse (plz);
create        index adr02 on adresse (suchname);

create table bankverbindung
(
  art          char,
  key          text,
  inhaber      text,
  nummer       text,
  blz          text,
  bank         text,
  bic          text,
  iban         text
);
create unique index bank00 on bankverbindung (art,key);

create table lieferant
(
  bez          text,
  tel          text,
  fax          text,
  zahlart      char,
  bukto        text
);
create unique index lief00 on lieferant (bez);
create        index lief01 on lieferant (bukto);

create table mitglied
(
  mid            int,
  intnr          int,
  gliederung     text,
  sex            char,
  nation         text,
  tel            text,
  gebdat         date,
  zahlart        char,
  beitrag        int64,
  eintritt       date,
  austritt       date,
  bezahlt        date,
  zahlstatus     char,
  statusdatum    date,
  wohngliederung text
);
create unique index mit00 on mitglied (mid);

create table spende
(
  jdatum       date,
  jlfd         integer,
  mid          int,
  sortname     text,
  art          char,
  gliederung   text,
  quittung     date,
  prozint      int,
  prozbuv      int,
  prozlv       int,
  prozbzv      int,
  prozkv       int,
  prozov       int
);
create unique index spe00 on spende (jdatum,jlfd);
create        index spe01 on spende (mid,jdatum);
create        index spe02 on spende (sortname,jdatum);
create        index spe03 on spende (gliederung,jdatum);

create table spendenparam
(
  art            char,
  prozint        int,
  prozbuv        int,
  prozlv         int,
  prozbzv        int,
  prozkv         int,
  prozov         int,
  midbuchung     char,
  kontokasse     text,
  kontobank      text,
  kontoanonkasse text,
  kontoanonbank  text,
  kontojurkasse  text,
  kontojurbank   text,
  kostkasse      text,
  kostbank       text,
  kostanonkasse  text,
  kostanonbank   text,
  kostjurkasse   text,
  kostjurbank    text
);
create unique index spp00 on spendenparam(art);

create table parameter
(
  key            text,
  wert           text
);
create unique index para00 on parameter(key);

create table textbaustein
(
  bez            text,
  beschreibung   text,
  subject        text,
  inhalt         text
);
create unique index text00 on textbaustein(bez);

create table zahllauf
(
  mid            int,
  sperren        char,
  art            char,
  form           char,
  manuell        char,
  bausteinm      text,
  bausteinb      text,
  cent           qint64,
  statusneu      char,
  done           char
);
create unique index zlauf00 on zahllauf (mid);
create        index art     on zahllauf (art,mid);

create table blzdatei
(
  land           text,
  blz            text,
  name           text,
  pruefart       text,
  bic            text
);
create unique index blz00 on blzdatei (land,blz);
create        index blz01 on blzdatei (bic);
