#include "druckfkt.h"
#include "utils.h"
#include "piraten.xpm"
#include "logo3d.xpm"

QImage wLogo(PiratenXPM);
QImage wLogo3D(Piraten3dXPM);

static int _flag_init=0;
static QFont _wFontNorm;
static QFont _wFontBold;

void DruckInit()
{
  if (_flag_init) return;
  _wFontNorm.setFamily("Helvetica");
  _wFontNorm.setWeight(QFont::Normal);
  _wFontNorm.setPointSize(10);
  _wFontBold.setFamily("Helvetica");
  _wFontBold.setWeight(QFont::Bold);
  _wFontBold.setPointSize(10);
  _flag_init=1;
}

static void _DruckBetrag(QPainter *wPainter, QFontMetrics *wMetrics,
                         qint64 betrag,int wPosX, int wPosY)
{
  QString s=QLocale::system().toString((double)betrag/(double)100.0l,'f',2);
  int     wPos;

  wPos=wPosX-wMetrics->width(s);
  if (betrag<0) wPainter->setPen(Qt::red);
  wPainter->drawText(wPos,wPosY,s);
  if (betrag<0) wPainter->setPen(Qt::black);
}

int DruckKonto(QPrinter *wPrinter, QPainter *wPainter, QString sKonto,
                QDate wVon, QDate wBis, QString sKost)
{
  DruckInit();
  wPainter->setFont(_wFontNorm);
  QFontMetrics wFontMetrics=wPainter->fontMetrics();
  int          wFontHeight=wFontMetrics.height();
  int          wPosY,wPosX,wWidth,wHeight,wWidth9,wWidthX;
  QString      sDrudat=QDateTime::currentDateTime().toString("dd.MM.yyyy hh:mm");
  int          wPosBelegS,wPosBelegE,wPosBetragS,wPosBetragE;
  int          wPosGKtoS,wPosGKtoE,wPosOpS,wPosOpE,wPosDatumS,wPosDatumE;
  int          wPosButextS,wPosButextE,wPosSaldoS,wPosSaldoE;
  int          wPosBeschlussS,wPosBeschlussE,wPosKontoText,wPosDrudat;
  int          wPosDrudatt,wPosKopfSaldo;
  qint64       wSAnf,wSEnd,wSaldo,wCent;
  int          wSeite,wAnzSeiten,wHeightText;
  int          i,wLauf;
  bool         flag_kopf;
  QString      s;
  QSqlQuery    q1,q2,q3;
  QDate        wGJVon=UtilGJVonDatum(wVon);
  QDate        wDat;
  QRect        wRect;
  bool         flag_kost;

  wWidth=wPrinter->pageRect().width();
  wHeight=wPrinter->pageRect().height();
  wWidth9=wFontMetrics.width("9");
  wWidthX=wFontMetrics.width("G");
  wPosBelegS=0;
  wPosBelegE=wPosBelegS+8*wWidthX;
  wPosBetragS=wPosBelegE+wWidthX;
  wPosBetragE=wPosBetragS+9*wWidth9;
  wPosGKtoS=wPosBetragE+wWidthX;
  wPosGKtoE=wPosGKtoS+wFontMetrics.width("1406#69999#99");
  wPosOpS=wPosGKtoE+wWidthX;
  wPosOpE=wPosOpS+wFontMetrics.width("zwBarSpende") + wWidthX;
  wPosDatumS=wPosOpE+wWidthX;
  wPosDatumE=wPosDatumS+wFontMetrics.width("88.88.8888");
  wPosButextS=wPosDatumE+wWidthX;
  wPosBeschlussE=wWidth;
  wPosBeschlussS=wPosBeschlussE-16*wWidth9;
  wPosSaldoE=wPosBeschlussS-wWidthX;
  wPosSaldoS=wPosSaldoE-10*wWidth9;
  wPosButextE=wPosSaldoS-wWidthX;
  wPosKontoText=wFontMetrics.width("Konto " + sKonto + ":") + wWidthX;
  i=wFontMetrics.width("Anfangssaldo:") + wWidthX;
  if (i>wPosKontoText) wPosKontoText=i;
  wPosDrudat = wWidth - wFontMetrics.width(sDrudat);
  wPosDrudatt = wPosDrudat - wFontMetrics.width("Druckdatum") - wWidthX;
  wPosKopfSaldo=wPosKontoText+wFontMetrics.width("88.88.8888") + 10 * wWidth9;
  flag_kost=(sKost.length()>0);

  wSAnf=0;
  for (wLauf=0; wLauf<2; wLauf++)
  {
    if (wLauf>0 && wAnzSeiten==0) break;
    flag_kopf=true;
    wSaldo=0;
    wSeite=0;
    wPosY=0;
    q1.exec("SELECT datum,lfd,cent,kg FROM kgkto WHERE konto='" +
             sKonto + "' AND datum>='" + wGJVon.toString("yyyy-MM-dd") +
             "' AND datum<='" + wBis.toString("yyyy-MM-dd") + "'");
    while(q1.next())
    {
      q2.exec("SELECT kost,butext,beschluss,beleg,art FROM journdat WHERE datum='" +
              q1.value(0).toString() + "' AND lfd='" +
              q1.value(1).toString() + "' LIMIT 1");
      if (!q2.next()) continue;
      if (flag_kost && q2.value(0).toString().toUpper() != sKost)
      {
         q2.finish();
         continue;
      }
      wDat = q1.value(0).toDate();
      wCent= q1.value(2).toLongLong();
      if (q2.value(4).toString()!="A" || wDat==wGJVon)
         wSaldo += wCent;
      if (wLauf<1)
      {
        if (wDat<wVon || (wDat==wVon && q2.value(4).toString()=="A"))
           wSAnf += wCent;
      }
      if (wDat<wVon) continue;

      wRect=wPainter->boundingRect(wPosButextS,0,wPosButextE-wPosButextS,
                      wHeight,Qt::TextWordWrap,q2.value(1).toString());
      if (wRect.height()<wFontHeight)
         wHeightText=wFontHeight;
      else
         wHeightText=wRect.height();
      if ((wPosY+wHeightText+wFontHeight) > wHeight) flag_kopf=true;
      if (flag_kopf)
      {
        if (wLauf>0 && wSeite>0) wPrinter->newPage();
        flag_kopf=false;
        wSeite++;
        wPosY=wPrinter->resolution()*100/254 + wFontHeight;
        if (wLauf==0)
          wPosY=wPosY+5*wFontHeight;
        else
        {
          wPainter->setFont(_wFontBold);
          wPainter->drawText(0,wPosY,"Konto " + sKonto + ": ");
          wPainter->drawText(wPosKontoText,wPosY,UtilKtoText(sKonto));
          wPainter->drawText(wPosDrudatt,wPosY,"Druckdatum");
          wPainter->drawText(wPosDrudat,wPosY,sDrudat);
          wPosY+=wFontHeight;
          wPainter->drawText(0,wPosY,"Anfangssaldo");
          wPainter->drawText(wPosKontoText,wPosY,wVon.toString("dd.MM.yyyy"));
          _DruckBetrag(wPainter,&wFontMetrics,wSAnf,wPosKopfSaldo,wPosY);
          wPainter->drawText(wPosKopfSaldo + wWidthX,wPosY,"EUR");
          wPainter->drawText(wPosDrudatt,wPosY,"Seite:");
          s=QString::number(wSeite) + "/" + QString::number(wAnzSeiten);
          wPainter->drawText(wWidth - wFontMetrics.width(s),wPosY,s);
          wPosY+=wFontHeight;
          wPainter->drawText(0,wPosY,"Endsaldo");
          wPainter->drawText(wPosKontoText,wPosY,wBis.toString("dd.MM.yyyy"));
          _DruckBetrag(wPainter,&wFontMetrics,wSEnd,wPosKopfSaldo,wPosY);
          wPainter->drawText(wPosKopfSaldo + wWidthX,wPosY,"EUR");
          if (flag_kost)
          {
             wPainter->drawText(wPosDatumS,wPosY,"OP-Name");
             wPainter->drawText(wPosButextS,wPosY,sKost);
          }
          wPosY+=wFontHeight;
          wPosY+=wFontHeight;
          wPainter->drawText(wPosBelegE-wFontMetrics.width("Beleg"),wPosY,
                             "Beleg");
          wPainter->drawText(wPosBetragE-wFontMetrics.width("Betrag"),wPosY,
                             "Betrag");
          wPainter->drawText(wPosGKtoS,wPosY,"G.-Konto");
          wPainter->drawText(wPosOpS,wPosY,"OP-Name");
          wPainter->drawText(wPosDatumS,wPosY,"Datum");
          wPainter->drawText(wPosButextS,wPosY,"Buchungstext");
          wPainter->drawText(wPosSaldoE-wFontMetrics.width("Saldo"),wPosY,
                             "Saldo");
          wPainter->drawText(wPosBeschlussS,wPosY,"Beschluss");
          wPosY+=wFontHeight;
          wPainter->setFont(_wFontNorm);
        }
      }
      if (wLauf> 0)
      {
        wPainter->drawText(wPosBelegE-wFontMetrics.width(q2.value(3).toString())
                          ,wPosY,q2.value(3).toString());
        _DruckBetrag(wPainter,&wFontMetrics,wCent,wPosBetragE,wPosY);
        q3.exec("SELECT konto FROM kgkto WHERE datum='" +
                q1.value(0).toString() + "' AND lfd='" +
                q1.value(1).toString() + "' AND kg!='" +
                q1.value(3).toString() + "'");
        if (q3.next())
        {
          wPainter->drawText(wPosGKtoS,wPosY,q3.value(0).toString());
          q3.finish();
        }
        wPainter->drawText(wPosOpS,wPosY,q2.value(0).toString());
        wPainter->drawText(wPosDatumS,wPosY,
                           q1.value(0).toDate().toString("dd.MM.yyyy"));
        wPainter->drawText(wPosButextS,wPosY-wFontMetrics.ascent(),
                      wPosButextE-wPosButextS,wHeight,
                      Qt::TextWordWrap|Qt::AlignTop,q2.value(1).toString());
        _DruckBetrag(wPainter,&wFontMetrics,wSaldo,wPosSaldoE,wPosY);
        wPainter->drawText(wPosBeschlussS,wPosY,q2.value(2).toString());
      }
      wPosY=wPosY+wHeightText;
    }
    wAnzSeiten=wSeite;
    wSEnd=wSaldo;
  }
  if (wAnzSeiten==0)
  {
    wSeite++;
    wAnzSeiten=1;
    wPosY=wPrinter->resolution()*100/254 + wFontHeight;
    wPainter->setFont(_wFontBold);
    wPainter->drawText(0,wPosY,"Konto " + sKonto + ": ");
    wPainter->drawText(wPosKontoText,wPosY,UtilKtoText(sKonto));
    wPainter->drawText(wPosDrudatt,wPosY,"Druckdatum");
    wPainter->drawText(wPosDrudat,wPosY,sDrudat);
    wPosY+=wFontHeight;
    wPainter->drawText(0,wPosY,"Anfangssaldo");
    wPainter->drawText(wPosKontoText,wPosY,wVon.toString("dd.MM.yyyy"));
    _DruckBetrag(wPainter,&wFontMetrics,wSAnf,wPosKopfSaldo,wPosY);
    wPainter->drawText(wPosKopfSaldo + wWidthX,wPosY,"EUR");
    wPainter->drawText(wPosDrudatt,wPosY,"Seite:");
    s=QString::number(wSeite) + "/" + QString::number(wAnzSeiten);
    wPainter->drawText(wWidth - wFontMetrics.width(s),wPosY,s);
    wPosY+=wFontHeight;
    wPainter->drawText(0,wPosY,"Endsaldo");
    wPainter->drawText(wPosKontoText,wPosY,wBis.toString("dd.MM.yyyy"));
    _DruckBetrag(wPainter,&wFontMetrics,wSEnd,wPosKopfSaldo,wPosY);
    wPainter->drawText(wPosKopfSaldo + wWidthX,wPosY,"EUR");
    wPosY+=wFontHeight;
    wPosY+=wFontHeight;
    wPainter->drawText(0,wPosY,"Keine Buchungen im ausgewhten Zeitraum");
  }
  return(wAnzSeiten);
}

#define MAXZUWEND 100  /* Maximale Anzahl Quittungen pro Mitglied */

static struct  t_zuwend wZuwend[MAXZUWEND];
static int     wZuwendAnz;
static int     _wZuwendMid;
static QString _wZuwendAdr1,_wZuwendAdr2,_wZuwendAdr3;
static bool    _fZwispende=false;

/* --- Fuelle wZuwend mit den offenen Zuwendungen mit Mitglied mid --- */
int PrepareZuwend(int mid, int iDoppel, QDate vonJDat, QDate bisJDat,
                  QDate vonDrudat, QDate bisDrudat, bool flag_min)
{
  QSqlQuery query,query2;
  qint64    cent,cent0;
  QString   smk;
  int       i,j,j0;
  QDate     wHeute=QDate::currentDate();
  bool      flag_anon;

  wZuwendAnz=0;
  flag_anon=false;
  smk=UtilMIDKonto(-1);
  _wZuwendMid=mid;
  smk=smk.sprintf("%08i",mid);
  query.exec("SELECT name2,name1,strasse,plz,ort FROM adresse WHERE art='M' AND key='" +
             smk + "'");
  if (query.next())
  {
    if (query.value(3).toString() == "ZZZZZ") flag_anon=true;
    _wZuwendAdr1=query.value(0).toString();
    if (_wZuwendAdr1.length()>0 && query.value(1).toString().length()>0)
       _wZuwendAdr1=_wZuwendAdr1 + " " + query.value(1).toString();
    _wZuwendAdr2=query.value(2).toString();
    _wZuwendAdr3=query.value(3).toString();
    if (_wZuwendAdr3.length()>0 && query.value(4).toString().length()>0)
       _wZuwendAdr3=_wZuwendAdr3 + " " + query.value(4).toString();
    query.finish();
  }
  else
    _wZuwendAdr1=_wZuwendAdr2=_wZuwendAdr3="";

  if (flag_anon) return(0);

  query.exec("SELECT jdatum,jlfd,art,quittung FROM spende WHERE mid='" +
             QString::number(mid) +
             "' AND jdatum>='" + vonJDat.toString("yyyy-MM-dd") +
             "' AND jdatum<='" + bisJDat.toString("yyyy-MM-dd") +
             "' AND art!='S' ORDER BY mid,jdatum,jlfd,art");
  while(query.next() && wZuwendAnz<MAXZUWEND)
  {
    if (query.value(3).toDate().year()>2000)
    {
      if (iDoppel==0) continue;
      if (query.value(3).toDate() < vonDrudat ||
          query.value(3).toDate() > bisDrudat)
         continue;
    }
    else
    {
      if (iDoppel==1) continue;
    }
    query2.exec("SELECT konto,cent FROM kgkto WHERE datum='" +
                query.value(0).toString() + "' AND lfd='" +
                query.value(1).toString() + "' AND kg='1' LIMIT 1");
    if (query2.next())
    {
      cent=query2.value(1).toLongLong();
      if (query2.value(0).toString()>="1000" &&
          query2.value(0).toString()<="1200")
         cent=1*cent;
      else if (query2.value(0).toString().left(smk.length())==smk)
         cent=-1*cent;
      else if (query2.value(0).toString()>="5000" &&
               query2.value(0).toString()<="5299")
         cent=-1*cent;
      else
         cent=1*cent;
      wZuwend[wZuwendAnz].jdatum=query.value(0).toDate();
      wZuwend[wZuwendAnz].jlfd  =query.value(1).toInt();
      wZuwend[wZuwendAnz].cent  =cent;
      wZuwend[wZuwendAnz].art   =query.value(2).toString();
      if (query.value(3).toDate().year()<2000)
         wZuwend[wZuwendAnz].druckdatum=wHeute;
      else
         wZuwend[wZuwendAnz].druckdatum=query.value(3).toDate();
      query2.finish();
      wZuwendAnz++;
    }
  }
  query.finish();

  /* --- Ruecklastschriften rausfiltern --- */
  for (i=0; i<wZuwendAnz; i++) if (wZuwend[i].cent<0)
  {
    cent=wZuwend[i].cent * -1;
    cent0=99999999;
    j0=-1;
    for (j=0; j<wZuwendAnz; j++)
    {
      if (wZuwend[j].cent<=cent && wZuwend[i].cent<cent0 &&
          wZuwend[j].jdatum<=wZuwend[i].jdatum)
      {
         j0=j;
         cent0=wZuwend[i].cent;
      }
    }
    if (j0<0)
    { /* --- Negativbetrag ohne Gegenstueck -> nichts erstellen --- */
      return(0);
    }
    else
    {
      wZuwend[i].cent=0;
      wZuwend[j0].cent=0;
    }
  }
  /* --- 0-er rauswerfen und gleiche Daten zusammenfassen --- */
  for (i=j=cent=0,j0=-1; i<wZuwendAnz; i++) if (wZuwend[i].cent>=0)
  {
    if (wZuwend[i].cent>0)
    {
      cent= cent + wZuwend[i].cent;
      if (j0>=0 && wZuwend[j0].jdatum==wZuwend[i].jdatum &&
          ((wZuwend[j0].art=="A" && wZuwend[i].art=="A") ||
           (wZuwend[j0].art!="A" && wZuwend[i].art!="A")    )  )
      {
        wZuwend[j0].cent += wZuwend[i].cent;
        wZuwend[i].cent=0;
      }
      else
         j0=j;
      if (i>j) wZuwend[j]=wZuwend[i];
      j++;
    }
    else
    { /* --- 0-er als abgearbeitet markieren --- */
      query.exec("UPDATE spende SET quittung='2200-12-31' WHERE jdatum='" +
                 wZuwend[i].jdatum.toString("yyyy-MM-dd") + "' AND jlfd='" +
                 QString::number(wZuwend[i].jlfd) + "'");
    }
  }
  wZuwendAnz=j;
  if (flag_min && cent<UtilSpendeMin())
     wZuwendAnz=0;
  return(wZuwendAnz);
}

bool DruckZuwend(QPrinter *wPrinter,QPainter *wPainter,int lfd,bool flag_1st)
{
  int wDpi,wSizeX,wSizeY,wBorderL,wBorderR,wBorderT,wBorderB;
  int x,y,r;
  QString s;
  QSqlQuery query;

  if (lfd<0 || lfd>=wZuwendAnz || wZuwend[lfd].art=="S") return(false);

  if (_fZwispende)
     query.exec("INSERT INTO zwispende(jdatum,jlfd,drudat) VALUES('" +
                wZuwend[lfd].jdatum.toString("yyyy-MM-dd") + "','" +
                QString::number(wZuwend[lfd].jlfd) + "','" +
                wZuwend[lfd].druckdatum.toString("yyyy-MM-dd") + "')");

  /* --- Wurde mit anderem Zusammengefasst --- */
  if (wZuwend[lfd].cent==0) return(false);

  if (flag_1st)
     wPainter->begin(wPrinter);
  else
     wPrinter->newPage();

  DruckInit();

  wDpi=wPrinter->resolution();
  wSizeX=wPrinter->paperRect().width();
  wSizeY=wPrinter->paperRect().height();
  wBorderL=wPrinter->pageRect().left();
  wBorderT=wPrinter->pageRect().top();
  wBorderR=wSizeX - wPrinter->pageRect().right();
  wBorderB=wSizeY - wPrinter->pageRect().bottom();

  wPainter->drawImage(QRect(wDpi-wBorderL,wDpi*5/8-wBorderT,
                            wDpi*2,wDpi*277/400),wLogo3D);
  wPainter->save();
  QPen wPen(Qt::black);
  wPen.setWidth(wDpi/100);
  wPainter->setPen(wPen);
  wPainter->drawRect(wDpi-wBorderL,wDpi*2+wDpi*6/16-wBorderT,
                     wDpi*3+wDpi*6/8,wDpi+wDpi/8);
  wPainter->drawRect(wDpi-wBorderL,wDpi*4+wDpi*8/16-wBorderT,
                     wDpi*6+wDpi*12/16,wDpi+wDpi/16);
  wPainter->drawRect(wDpi-wBorderL,wDpi*5+wDpi*11/16-wBorderT,
                     wDpi*6+wDpi*6/8,wDpi/2);
  wPainter->drawLine(wDpi-wBorderL,wDpi*9+wDpi*8/16-wBorderT,
                     wDpi-wBorderL+wDpi*6+wDpi*6/8,wDpi*9+wDpi*8/16-wBorderT);
  wPainter->drawEllipse(wDpi*5-wBorderL+wDpi*14/16,wDpi*6+wDpi*7/16-wBorderT,
                        wDpi*4/16,wDpi*4/16);
  wPainter->drawEllipse(wDpi*6-wBorderL+wDpi*11/16,wDpi*6+wDpi*7/16-wBorderT,
                        wDpi*4/16,wDpi*4/16);
  if (wZuwend[lfd].art=="A")
     x=wDpi*6-wBorderL;
  else
     x=wDpi*6+wDpi*13/16-wBorderL;
  y=wDpi*6+wDpi*9/16-wBorderT;
  r=wDpi*3/32;
  wPainter->drawLine(x-r,y-r,x+r,y+r);
  wPainter->drawLine(x-r,y+r,x+r,y-r);
  wPainter->restore();

  _wFontBold.setPointSizeF(19.6l);
  wPainter->setFont(_wFontBold);
  {
    QFontMetrics fm1(_wFontBold,wPrinter);
    s="Besttigung ber Geldzuwendung / Mitgliedsbeitrag";
    x=wDpi-wBorderL;
    y=wDpi*4-wBorderT;
    wPainter->drawText(x,y,s);
  }
  _wFontNorm.setPointSizeF(9.7l);
  wPainter->setFont(_wFontNorm);
  {
    QFontMetrics fm1(_wFontNorm,wPrinter);
    s="Im Sinne des  34g,  10b des Einkommensteuergesetzes an politische Parteien im Sinne des Parteiengesetzes";
    x=wDpi-wBorderL;
    y=wDpi*4+wDpi*5/16-wBorderT;
    wPainter->drawText(x,y,s);
  }
  _wFontNorm.setPointSizeF(10.2l);
  wPainter->setFont(_wFontNorm);
  {
    QFontMetrics fm1(_wFontNorm,wPrinter);
    s="Es wird besttigt, dass diese Zuwendung ausschlielich fr die satzungsgemen Zwecke verwendet wird.";
    x=wDpi-wBorderL;
    y=wDpi*7+wDpi*1/16-wBorderT;
    wPainter->drawText(x,y,s);
    s="Es handelt sich um den Verzicht auf Erstattung von Aufwendungen";
    y=wDpi*6+wDpi*10/16-wBorderT;
    wPainter->drawText(x,y,s);
    x=wDpi*6+wDpi*3/16-wBorderL;
    wPainter->drawText(x,y,"Ja");
    x=wDpi*7-wBorderL;
    wPainter->drawText(x,y,"Nein");
  }
  _wFontBold.setPointSize(9);
  wPainter->setFont(_wFontBold);
  {
    x=wDpi-wBorderL;
    y=wDpi*10+wDpi*7/16-wBorderT;
    wPainter->drawText(x,y,"Hinweis:");
  }
  _wFontNorm.setPointSize(8);
  wPainter->setFont(_wFontNorm);
  {
    QFontMetrics fm1(_wFontNorm,wPrinter);
    x=wDpi-wBorderL;
    y=wDpi*10+wDpi*11/16-wBorderT;
    s="Wer vorstzlich oder grob fahrlssig eine unrichtige Zuwendungsbesttigung erstellt oder wer veranlasst, dass Zuwendungen nicht zu";
    wPainter->drawText(x,y,s);
    y=y+fm1.ascent()+fm1.descent();
    s="den in der Zuwendungsbesttigung angegebenen steuerbegnstigten Zwecken verwendet werden, haftet fr die Steuer, die dem Fiskus";
    wPainter->drawText(x,y,s);
    y=y+fm1.ascent()+fm1.descent();
    s="durch einen etwaigen Abzug der Zuwendungen beim Zuwender entgeht ( 34g Satz 3,  10b Abs. 4 EStG,  9 Abs. 3 KStG,  9 Nr. 5";
    wPainter->drawText(x,y,s);
    y=y+fm1.ascent()+fm1.descent();
    s="GewStG).";
    wPainter->drawText(x,y,s);
  }
  _wFontBold.setPointSize(20);
  wPainter->setFont(_wFontBold);
  {
    QFontMetrics fm1(_wFontBold,wPrinter);
    s="Piratenpartei Deutschland";
    x=wSizeX - wDpi/2 - wBorderL - fm1.width(s);
    y=wDpi*5/8-wBorderT+fm1.ascent();
    wPainter->drawText(x,y,s);
    y=y+fm1.descent();
  }
  _wFontNorm.setPointSize(10);
  wPainter->setFont(_wFontNorm);
  {
    QFontMetrics fm1(_wFontNorm,wPrinter);
    s=UtilSpendeAdr(1);
    y=y+fm1.ascent();
    wPainter->drawText(x,y,s);
    y=y+(fm1.ascent()+fm1.descent());
    y=y+(fm1.ascent()+fm1.descent());
    s=UtilSpendeAdr(2);
    wPainter->drawText(x,y,s);
    y=y+(fm1.ascent()+fm1.descent());
    s=UtilSpendeAdr(3);
    wPainter->drawText(x,y,s);
    y=wDpi*4+wDpi*6/8-wBorderT+fm1.ascent()*3/2;
    x=wDpi-wBorderL+wDpi*1/16;
    wPainter->drawText(x,y,_wZuwendAdr1);
    y=y+(fm1.ascent()+fm1.descent());
    if (_wZuwendMid>0 && _wZuwendMid<1000000)
    {
      wPainter->drawText(x,y,"Mitgliedsnummer " + QString::number(_wZuwendMid));
    }
    y=y+(fm1.ascent()+fm1.descent());
    wPainter->drawText(x,y,_wZuwendAdr2);
    y=y+(fm1.ascent()+fm1.descent());
    wPainter->drawText(x,y,_wZuwendAdr3);
    s=UtilSpendeAdr(4) + ", den " +
      wZuwend[lfd].druckdatum.toString("dd.MM.yyyy") + ", " +
      UtilSpendeAdr(5);
    wPainter->drawText(wDpi-wBorderL,
                       wDpi*9+wDpi*8/16-wBorderT-fm1.ascent()*3/2,s);
    s=QLocale::system().toString((double)wZuwend[lfd].cent/(double)100.0l,
                                 'f',2);
    x=wDpi-wBorderL+wDpi*1/16;
    y=wDpi*5+wDpi*15/16-wBorderT+fm1.ascent();
    wPainter->drawText(x,y,s);
    s=UtilZahlwort(wZuwend[lfd].cent);
    x=wDpi*4-wBorderL+wDpi*6/16 - fm1.width(s)/2;
    wPainter->drawText(x,y,s);
    s=wZuwend[lfd].jdatum.toString("dd.MM.yyyy");
    x=wDpi*7+wDpi*11/16-wBorderL-fm1.width(s);
    wPainter->drawText(x,y,s);
  }
  _wFontNorm.setPointSize(8);
  wPainter->setFont(_wFontNorm);
  {
    QFontMetrics fm1(_wFontNorm,wPrinter);
    wPainter->drawText(wDpi-wBorderL,wDpi*2+wDpi*5/16-wBorderT-fm1.descent(),
                       UtilSpendeAdr(6));
    x=wDpi-wBorderL+wDpi*1/16;
    y=wDpi*4+wDpi*9/16-wBorderT+fm1.ascent();
    wPainter->drawText(x,y,"Name und Anschrift des Zuwendenden");
    y=wDpi*5+wDpi*12/16-wBorderT+fm1.ascent();
    wPainter->drawText(x,y,"Betrag der Zuwendung  - in Ziffern -");
    s="Tag der Zuwendung:";
    x=wDpi*7+wDpi*11/16-wBorderL-fm1.width(s);
    wPainter->drawText(x,y,s);
    s="- in Buchstaben -";
    x=wDpi*4-wBorderL+wDpi*6/16 - fm1.width(s)/2;
    wPainter->drawText(x,y,s);
    x=wDpi-wBorderL;
    y=wDpi*9+wDpi*9/16-wBorderT + fm1.ascent();
    wPainter->drawText(x,y,"Ort, Datum, Funktion");
  }
  _wFontNorm.setPointSize(12);
  wPainter->setFont(_wFontNorm);
  {
    QFontMetrics fm1(_wFontNorm,wPrinter);
    y=wDpi*2+wDpi*5/8-wBorderT+fm1.ascent()*3/2;
    x=wDpi-wBorderL+wDpi*2/16;
    wPainter->drawText(x,y,_wZuwendAdr1);
    y=y+(fm1.ascent()+fm1.descent());
    wPainter->drawText(x,y,_wZuwendAdr2);
    y=y+(fm1.ascent()+fm1.descent());
    wPainter->drawText(x,y,_wZuwendAdr3);
  }
  _wFontBold.setPointSize(10);
  _wFontNorm.setPointSize(10);
  return(true);
}

void ZuwendZwidatStart()
{
  QSqlQuery query;

  if (_fZwispende)
     query.exec("DELETE FROM zwispende");
  else
     query.exec("CREATE temporary table zwispende (jdatum date,jlfd int,drudat date, PRIMARY KEY(jdatum,jlfd ASC))");
  _fZwispende=true;
}

void ZuwendZwidatEnd(bool fBuch)
{
  QSqlQuery query,query2;

  if (!_fZwispende) return;

  if (fBuch)
  {
    query.exec("SELECT jdatum,jlfd,drudat FROM zwispende");
    while(query.next())
    {
      query2.exec("UPDATE spende SET quittung='" +
                  query.value(2).toString() + "' WHERE jdatum='" +
                  query.value(0).toString() + "' AND jlfd='" +
                  query.value(1).toString() + "'");
    }
    query.finish();
  }
  query.exec("DROP TABLE zwispende");
  _fZwispende=false;
}
