#include <QtGui>
#include <QSqlQuery>

#include "gliederung.h"
#include "utils.h"

Gliederung::Gliederung(QWidget *parent) : QDialog(parent)
{
  QLabel *l;

  sUnterAlt="";

  QVBoxLayout *topLayout = new QVBoxLayout();
  QHBoxLayout *bezLayout = new QHBoxLayout();
  QHBoxLayout *buttonLayout = new QHBoxLayout();
  QGridLayout *allgLayout = new QGridLayout();
  QGridLayout *kontaktLayout = new QGridLayout();
  QGridLayout *bankLayout    = new QGridLayout();
  QTabWidget *wTabWidget = new QTabWidget();
  QWidget    *wTabAllg = new QWidget();
  QWidget    *wTabKontakt = new QWidget();
  QWidget    *wTabBank    = new QWidget();

  wTabWidget->addTab(wTabAllg,"A&dresse");
  wTabWidget->addTab(wTabKontakt,"&Kontakte");
  wTabWidget->addTab(wTabBank,"&Bankverbindung");

  topLayout->addLayout(bezLayout);
  topLayout->addWidget(wTabWidget);
  topLayout->addLayout(buttonLayout);

  setWindowTitle("Gliederungen");
  bOk = new QPushButton("&Speichern");
  bCancel = new QPushButton("&Abbruch");
  bDel = new QPushButton("&Lschen");
  bOk->setAutoDefault(false);
  bCancel->setAutoDefault(false);
  bDel->setAutoDefault(false);

  wNameKurz=new QLineEdit(this);   wNameKurz->setFixedSize(350,25);
  wAdresse=new WAdresse(0,this);
  wEbene=new QComboBox(this);      wEbene->setFixedSize(200,25);
  wUnter=new WGliederung(this);    wUnter->setFixedSize(350,25);
  wBukto=new QLineEdit(this);      wBukto->setFixedSize(150,25);
  wBank=new WBank(this);
  wVors=new QLineEdit(this);       wVors->setFixedSize(525,25);
  wVorsTel=new QLineEdit(this);    wVorsTel->setFixedSize(250,25);
  wVorsFax=new QLineEdit(this);    wVorsFax->setFixedSize(250,25);
  wVorsMail=new QLineEdit(this);   wVorsMail->setFixedSize(525,25);
  wSchatz=new QLineEdit(this);     wSchatz->setFixedSize(525,25);
  wSchatzTel=new QLineEdit(this);  wSchatzTel->setFixedSize(250,25);
  wSchatzFax=new QLineEdit(this);  wSchatzFax->setFixedSize(250,25);
  wSchatzMail=new QLineEdit(this); wSchatzMail->setFixedSize(525,25);
  wGensek=new QLineEdit(this);     wGensek->setFixedSize(525,25);
  wGensekTel=new QLineEdit(this);  wGensekTel->setFixedSize(250,25);
  wGensekFax=new QLineEdit(this);  wGensekFax->setFixedSize(250,25);
  wGensekMail=new QLineEdit(this); wGensekMail->setFixedSize(525,25);
  wGegruendet=new QDateEdit(); wGegruendet->setDisplayFormat("dd.MM.yyyy");
  wGegruendet->setFixedSize(wGegruendet->sizeHint());
  wListe = new QTreeView;

  wNameKurz->setMaxLength(40);
  wBukto->setMaxLength(15);
  wVors->setMaxLength(60);
  wVorsTel->setMaxLength(25);
  wVorsFax->setMaxLength(25);
  wVorsMail->setMaxLength(60);

  wModel = new GliederungsBaum();
  wListe->setModel(wModel);
  wListe->setEnabled(true);
  topLayout->addWidget(wListe);

  wEbene->insertItem(0,"Bundesverband");
  wEbene->insertItem(1,"Landesverband");
  wEbene->insertItem(2,"Bezirksverband");
  wEbene->insertItem(3,"Kreisverband");
  wEbene->insertItem(4,"Ortsverband");

  l=new QLabel("Bezeichnung");
  bezLayout->addWidget(l);
  bezLayout->addWidget(wNameKurz);
  bezLayout->addStretch(1);

  wAdresse->FuellLayout(allgLayout,1,1);
  l=new QLabel("Art");
  allgLayout->addWidget(l,6,1,1,2);
  allgLayout->addWidget(wEbene,6,2,1,2);
  l=new QLabel("Unter");
  allgLayout->addWidget(l,7,1);
  allgLayout->addWidget(wUnter,7,2,1,3);
  l=new QLabel("Gegrndet");
  allgLayout->addWidget(l,8,1);
  allgLayout->addWidget(wGegruendet,8,2,1,2);
  allgLayout->setRowStretch(99,1);
  allgLayout->setColumnStretch(99,1);

  l=new QLabel("Vorsitzender");
  kontaktLayout->addWidget(l,1,1);
  kontaktLayout->addWidget(wVors,1,2,1,6);
  l=new QLabel("Tel./Fax");
  kontaktLayout->addWidget(l,2,1);
  kontaktLayout->addWidget(wVorsTel,2,2,1,3);
  kontaktLayout->addWidget(wVorsFax,2,5,1,3);
  l=new QLabel("Email");
  kontaktLayout->addWidget(l,3,1);
  kontaktLayout->addWidget(wVorsMail,3,2,1,6);
  kontaktLayout->setRowStretch(99,1);
  kontaktLayout->setColumnStretch(99,1);

  l=new QLabel("Schatzmeister");
  kontaktLayout->addWidget(l,4,1);
  kontaktLayout->addWidget(wSchatz,4,2,1,6);
  l=new QLabel("Tel./Fax");
  kontaktLayout->addWidget(l,5,1);
  kontaktLayout->addWidget(wSchatzTel,5,2,1,3);
  kontaktLayout->addWidget(wSchatzFax,5,5,1,3);
  l=new QLabel("Email");
  kontaktLayout->addWidget(l,6,1);
  kontaktLayout->addWidget(wSchatzMail,6,2,1,6);

  l=new QLabel("Gensek");
  kontaktLayout->addWidget(l,7,1);
  kontaktLayout->addWidget(wGensek,7,2,1,6);
  l=new QLabel("Tel./Fax");
  kontaktLayout->addWidget(l,8,1);
  kontaktLayout->addWidget(wGensekTel,8,2,1,3);
  kontaktLayout->addWidget(wGensekFax,8,5,1,3);
  l=new QLabel("Email");
  kontaktLayout->addWidget(l,9,1);
  kontaktLayout->addWidget(wGensekMail,9,2,1,6);

  l=new QLabel("Buchungskonto");
  bankLayout->addWidget(l,1,1);
  bankLayout->addWidget(wBukto,1,2);
  wBank->FuellLayout(bankLayout,2,1);
  bankLayout->setColumnStretch(4,1);
  bankLayout->setRowStretch(99,1);
  bankLayout->setColumnStretch(99,1);

  buttonLayout->addWidget(bOk);
  buttonLayout->addWidget(bCancel);
  buttonLayout->addWidget(bDel);
  buttonLayout->addStretch(1);
  
  wTabAllg->setLayout(allgLayout);
  wTabKontakt->setLayout(kontaktLayout);
  wTabBank->setLayout(bankLayout);
  setLayout(topLayout);

  pFuellListe("");
  pSetWahl(true);

  connect(wNameKurz,SIGNAL(returnPressed()),this,SLOT(pRead()));
  connect(wNameKurz,SIGNAL(editingFinished()),this,SLOT(pRead()));
  connect(bOk,SIGNAL(clicked()),this,SLOT(pWrite()));
  connect(bDel,SIGNAL(clicked()),this,SLOT(pDelete()));
  connect(bCancel,SIGNAL(clicked()),this,SLOT(pCancel()));
  connect(wEbene,SIGNAL(currentIndexChanged(int)),this,SLOT(pEbene(int)));
  connect(wListe,SIGNAL(clicked(QModelIndex)),this,SLOT(pAuswahl(QModelIndex)));
}

Gliederung::~Gliederung()
{
  delete wBank;
  delete wAdresse;
}

void Gliederung::pSetWahl(bool flag_wahl)
{
  fWahl=flag_wahl;

  wNameKurz->setEnabled(flag_wahl);

  wAdresse->setEnabled(!flag_wahl);
  wBank->setEnabled(!flag_wahl);
  wBukto->setEnabled(!flag_wahl);
  wEbene->setEnabled(!flag_wahl);
  wUnter->setEnabled(!flag_wahl);
  wGegruendet->setEnabled(!flag_wahl);
  wVors->setEnabled(!flag_wahl);
  wVorsTel->setEnabled(!flag_wahl);
  wVorsFax->setEnabled(!flag_wahl);
  wVorsMail->setEnabled(!flag_wahl);
  wSchatz->setEnabled(!flag_wahl);
  wSchatzTel->setEnabled(!flag_wahl);
  wSchatzFax->setEnabled(!flag_wahl);
  wSchatzMail->setEnabled(!flag_wahl);
  wGensek->setEnabled(!flag_wahl);
  wGensekTel->setEnabled(!flag_wahl);
  wGensekFax->setEnabled(!flag_wahl);
  wGensekMail->setEnabled(!flag_wahl);
  bOk->setEnabled(!flag_wahl);
  bDel->setEnabled(!flag_wahl);
  bCancel->setEnabled(!flag_wahl);

  if (flag_wahl)
  {
    wAdresse->clear();
    wBank->clear();
    wNameKurz->setText("");
    wBukto->setText("");
    wEbene->setCurrentIndex(0);
    wUnter->setText("");
    wGegruendet->setDate(QDate(1900,1,1));
    wVors->setText("");
    wVorsTel->setText("");
    wVorsFax->setText("");
    wVorsMail->setText("");
    wSchatz->setText("");
    wSchatzTel->setText("");
    wSchatzFax->setText("");
    wSchatzMail->setText("");
    wGensek->setText("");
    wGensekTel->setText("");
    wGensekFax->setText("");
    wGensekMail->setText("");
  }
  if (flag_wahl)
    wNameKurz->setFocus();
  else if (wAdresse->isEmpty())
    wAdresse->Name1()->setFocus();
  else
    bCancel->setFocus();
}

void Gliederung::pRead()
{
  QSqlQuery query;

  sUnterAlt="";
  pFelder();
  wNameKurz->setText(sNameKurz);
  if (!fWahl || sNameKurz.length()<1) return;
  query.exec("SELECT gegruendet,ebene,teilvon,bukto,vorsitzname,vorsitzmail,vorsitztel,vorsitzfax,gensekname,gensekmail,gensektel,gensekfax,schatzname,schatzmail,schatztel,schatzfax FROM verband WHERE namekurz='" + sNameKurz + "'");
  if (query.next())
  {
    wGegruendet->setDate(query.value(0).toDate());
    wEbene->setCurrentIndex(query.value(1).toInt());
    wUnter->setText(query.value(2).toString());
    wBukto->setText(query.value(3).toString());
    wVors->setText(query.value(4).toString());
    wVorsMail->setText(query.value(5).toString());
    wVorsTel->setText(query.value(6).toString());
    wVorsFax->setText(query.value(7).toString());
    wGensek->setText(query.value(8).toString());
    wGensekMail->setText(query.value(9).toString());
    wGensekTel->setText(query.value(10).toString());
    wGensekFax->setText(query.value(11).toString());
    wSchatz->setText(query.value(12).toString());
    wSchatzMail->setText(query.value(13).toString());
    wSchatzTel->setText(query.value(14).toString());
    wSchatzFax->setText(query.value(15).toString());
    query.finish();
    sUnterAlt=wUnter->text();
    wUnter->setEbene(wEbene->currentIndex());
  }
  wAdresse->read("V",sNameKurz);
  wBank->read("V",sNameKurz);
  pSetWahl(false);
}

void Gliederung::pCancel()
{
  if (fWahl)
    close();
  else
  {
    pSetWahl(true);
  }
}

void Gliederung::pFelder()
{
  sNameKurz=wNameKurz->text().replace("'","`").simplified().toUpper();
  sBukto=wBukto->text().replace("'","`").simplified();
  sUnter=wUnter->text().replace("'","`").simplified();
  sGegruendet=wGegruendet->date().toString("yyyy-MM-dd");
  sEbene.setNum(wEbene->currentIndex());
  sVors=wVors->text().replace("'","`").simplified();
  sVorsTel=wVorsTel->text().replace("'","`").simplified();
  sVorsFax=wVorsFax->text().replace("'","`").simplified();
  sVorsMail=wVorsMail->text().replace("'","`").simplified();
  sGensek=wGensek->text().replace("'","`").simplified();
  sGensekTel=wGensekTel->text().replace("'","`").simplified();
  sGensekFax=wGensekFax->text().replace("'","`").simplified();
  sGensekMail=wGensekMail->text().replace("'","`").simplified();
  sSchatz=wSchatz->text().replace("'","`").simplified();
  sSchatzTel=wSchatzTel->text().replace("'","`").simplified();
  sSchatzFax=wSchatzFax->text().replace("'","`").simplified();
  sSchatzMail=wSchatzMail->text().replace("'","`").simplified();

}

void Gliederung::pWrite()
{
  QSqlQuery query;

  if (fWahl) return;
  pFelder();
  if (wEbene->currentIndex()<1 &&
      wAdresse->Name1()->text().simplified().length()<1)
     return;

  query.exec("START TRANSACTION");
  query.exec("UPDATE verband SET gegruendet='" + sGegruendet +
              "',ebene='" + sEbene + "',teilvon='" + sUnter +
              "',bukto='" + sBukto + "',vorsitzname='" + sVors +
              "',vorsitzmail='" + sVorsMail + "',vorsitztel='" + sVorsTel +
              "',vorsitzfax='" + sVorsFax + "',gensekname='" + sGensek +
              "',gensekmail='" + sGensekMail + "',gensektel='" + sGensekTel +
              "',gensekfax='" + sGensekFax + "',schatzname='" + sSchatz +
              "',schatzmail='" + sSchatzMail + "',schatztel='" + sSchatzTel +
              "',schatzfax='" + sSchatzFax +
              "' WHERE namekurz='" + sNameKurz + "'");
  if (query.numRowsAffected()<1)
  {
    query.exec("INSERT INTO verband (namekurz,gegruendet,ebene,teilvon,bukto,vorsitzname,vorsitzmail,vorsitztel,vorsitzfax,gensekname,gensekmail,gensektel,gensekfax,schatzname,schatzmail,schatztel,schatzfax) VALUES ('" +
               sNameKurz + "','" + sGegruendet + "','" +
               sEbene + "','" + sUnter + "','" +
               sBukto + "','" + sVors + "','" +
               sVorsMail + "','" + sVorsTel + "','" +
               sVorsFax + "','" + sGensek + "','" +
               sGensekMail + "','" + sGensekTel + "','" +
               sGensekFax + "','" + sSchatz + "','" +
               sSchatzMail + "','" + sSchatzTel + "','" +
               sSchatzFax + "')");
  }
  wAdresse->write("V",sNameKurz);
  wBank->write("V",sNameKurz);
  query.exec("COMMIT TRANSACTION");
  pFuellListe(sNameKurz);
  pSetWahl(true);
}

void Gliederung::pDelete()
{
  QSqlQuery query;

  if (fWahl) return;
  if (UtilQDelete())
  {
    pFelder();
    query.exec("START TRANSACTION");
    wAdresse->del("V",sNameKurz);
    wBank->del("V",sNameKurz);
    query.exec("DELETE FROM verband WHERE namekurz='" + sNameKurz + "'");
    query.exec("COMMIT TRANSACTION");
    pFuellListe(sUnter);
    pSetWahl(true);
  }
}

void Gliederung::pFuellListe(QString sDarstell)
{
  int i;
  QStandardItem *wItem;
  QSqlQuery query;
  QModelIndex wIndex,wIndex1;

  wIndex=wModel->setupModelData(sDarstell);
  wIndex1=wIndex;
  while(wIndex.parent().isValid())
  {
    wIndex=wIndex.parent();
    wListe->setExpanded(wIndex,true);
  }
  wListe->setColumnWidth(0,250);
  wListe->setColumnWidth(1,120);
  if (wIndex1.isValid()) wListe->scrollTo(wIndex1);
}

void Gliederung::pAuswahl(QModelIndex i)
{
  int wZeile = i.row();

  if (fWahl)
  {
    wNameKurz->setText(wModel->datac(i,0).toString());
    pRead();
  }
}

void Gliederung::closeEvent(QCloseEvent *e)
{
  if (fWahl)
    e->accept();
  else
  {
    pCancel();
    e->ignore();
  }
}

void Gliederung::keyPressEvent(QKeyEvent *e)
{
  if (e->key()==Qt::Key_Escape)
  {
    if (fWahl)
       close();
    else
       pCancel();
    e->ignore();
  }
  e->accept();
}

void Gliederung::pEbene(int iNeu)
{
  wUnter->setEbene(iNeu);
}


