#ifndef GLIEDERUNG_H
#define GLIEDERUNG_H

#include <QWidget>
#include <QDialog>
#include <QLineEdit>
#include <QTableView>
#include "gliederungsbaum.h"
#include "wadresse.h"
#include "wbank.h"
#include "wgliederung.h"

QT_BEGIN_NAMESPACE
class QDialog;
class QLineEdit;
class QTableView;
QT_END_NAMESPACE

class Gliederung : public QDialog
{
  Q_OBJECT

public:
  Gliederung(QWidget *parent = NULL);
  ~Gliederung();

protected:
  void closeEvent(QCloseEvent *e);
  void keyPressEvent(QKeyEvent *e);

private:
  QTreeView          *wListe;
  GliederungsBaum    *wModel;
  QPushButton *bOk,*bCancel,*bDel;
  WAdresse    *wAdresse;
  WBank       *wBank;
  WGliederung *wUnter;
  QLineEdit   *wNameKurz,*wBukto;
  QComboBox   *wEbene;
  QLineEdit   *wVors,*wVorsTel,*wVorsFax,*wVorsMail;
  QLineEdit   *wGensek,*wGensekTel,*wGensekFax,*wGensekMail;
  QLineEdit   *wSchatz,*wSchatzTel,*wSchatzFax,*wSchatzMail;
  QDateEdit   *wGegruendet;
  QString     sNameKurz,sBukto,sEbene,sUnter,sGegruendet;
  QString     sVors,sVorsTel,sVorsFax,sVorsMail;
  QString     sGensek,sGensekTel,sGensekFax,sGensekMail;
  QString     sSchatz,sSchatzTel,sSchatzFax,sSchatzMail;
  QString     sUnterAlt;
  bool fWahl;

private:
  void pSetWahl(bool flag_wahl);
  void pFuellListe(QString sDarstell);
  void pFelder();

private slots:
  void pCancel();
  void pRead();
  void pWrite();
  void pDelete();
  void pEbene(int);
  void pAuswahl(QModelIndex);
};

#endif
