#ifndef JOURNAL_H
#define JOURNAL_H

#include <QtGui>
#include "wkonto.h"
#include "spende.h"

class Journal : public QDialog
{
  Q_OBJECT

public:
  Journal(QWidget *parent = NULL);
  ~Journal();
  int exec(QDate wBestDatum, int wBestlfd);
  int exec();

protected:
  void closeEvent(QCloseEvent *e);
  void keyPressEvent(QKeyEvent *e);

private:
  QDateEdit *wDatum;
  QLineEdit *wLfd;
  QLineEdit *wKost;
  QLineEdit *wBeleg;
  QLineEdit *wText;
  QLineEdit *wBeschluss;
  WKonto *wKonto;
  WKonto *wGKonto;
  QDoubleSpinBox *wBetrag;
  QTableView     *wListe;
  QStandardItemModel *wModel;
  QPushButton    *bSpende;
  QPushButton    *bOk,*bCancel,*bDel;
  QLabel         *lKontoText,*lGKontoText,*lSpenderName;
  bool           fWahl,fEinzeln;
  QString sDatum,sLfd,sKonto,sGKonto,sKost,sBeleg,sText,sBeschluss;
  int     iLfd;
  Spende wSpende;

private:
  void pSetWahl(bool flag_wahl);
  bool pCheck();
  void pFuellListe();
  void pFelder();

private slots:
  void pCancel();
  void pRead();
  void pWrite();
  void pDelete();
  void pEnter();
  void pAuswahl(QModelIndex);
  void pSpende();
};

#endif
