#include <QSqlQuery>

#include "journexport.h"
#include "utils.h"

JournalExport::JournalExport(QWidget *parent) : QDialog(parent)
{
  QLabel *l;
  QGridLayout *layout = new QGridLayout;
  int    y;

  setWindowTitle("Journal Export");
  wDatei.setFlags(false,false);

  bExport.setText("&Export");
  bCancel.setText("&Abbruch");
  wVonDat.setDate(UtilGJVon());
  wVonDat.setDisplayFormat("dd.MM.yyyy");
  wVonDat.setFixedSize(wVonDat.sizeHint());
  wBisDat.setDate(QDate::currentDate());
  wBisDat.setDisplayFormat("dd.MM.yyyy");
  wBisDat.setFixedSize(wBisDat.sizeHint());

  y=1;
  l=new QLabel("Datum von");
  layout->addWidget(l,y,1);
  layout->addWidget(&wVonDat,y,2);
  l=new QLabel("bis"); l->setAlignment(Qt::AlignRight);
  layout->addWidget(l,y,3);
  layout->addWidget(&wBisDat,y,4);
  y++;
  y=wDatei.FuellLayout(layout,y,1);
  layout->addWidget(&bExport,y,1);
  layout->addWidget(&bCancel,y,2);

  setLayout(layout);

  connect(&bExport,SIGNAL(clicked()),this,SLOT(pExport()));
  connect(&bCancel,SIGNAL(clicked()),this,SLOT(reject()));
}

JournalExport::~JournalExport()
{
}

void JournalExport::pExport()
{
  if (!wDatei.isValid()) return;

  QDate wVon=wVonDat.date();
  QDate wBis=wBisDat.date();
  QDate wGJVon=UtilGJVonDatum(wVon);
  QSqlQuery query1,query2;
  int       wExtLfd;
  qint64    wCent;
  QString   sKontoS;
  QString   sKontoH;
  double    wEur;

  wDatei.write("Nr.",true,false);
  wDatei.write("Datum",true,false);
  wDatei.write("Beleg",true,false);
  wDatei.write("Beleg_Text",true,false);
  wDatei.write("Betrag",true,false);
  wDatei.write("Kto_S",true,false);
  wDatei.write("Kto_H",true,true);
  wDatei.newLine();

  query1.exec("SELECT datum,lfd,kost,butext FROM journdat WHERE datum>='" +
              wGJVon.toString("yyyy-MM-dd") + "' AND datum<='" +
              wBis.toString("yyyy-MM-dd") + "' ORDER BY datum,lfd");
  for (wExtLfd=1; query1.next(); wExtLfd++)
  {
    if (query1.value(0).toDate() >= wVon)
    {
      wCent=0;
      sKontoS="";
      sKontoH="";
      query2.exec("SELECT konto,cent FROM kgkto WHERE datum='" +
                  query1.value(0).toString() + "' AND lfd='" +
                  query1.value(1).toString() + "' ORDER BY datum,lfd,kg");
      while(query2.next())
      {
        if (query2.value(1).toLongLong() < 0)
        {
          wCent=query2.value(1).toLongLong() * -1;
          sKontoH=query2.value(0).toString();
        }
        else
        {
          wCent=query2.value(1).toLongLong();
          sKontoS=query2.value(0).toString();
        }
      }
      wEur=(double)wCent/(double)100.0l;
      wDatei.write(QString::number(wExtLfd),false,false);
      wDatei.write(query1.value(0).toDate().toString("yyyy-MM-dd"),false,false);
      wDatei.write(query1.value(2).toString(),true,false);
      wDatei.write(query1.value(3).toString(),true,false);
      wDatei.write(QLocale::system().toString(wEur,'f',2),true,false);
      wDatei.write(sKontoS,true,false);
      wDatei.write(sKontoH,true,true);
      wDatei.newLine();
    }
  }
  wDatei.closeFile();
  QMessageBox::information(this,"Journalexport","Fertig");
  wVonDat.setFocus();
}
