#include <QtGui>
#include <QtSql>

#include "kplsuche.h"
#include "kontenplan.h"
#include "utils.h"

KplSuche::KplSuche(bool flag_anlegen, QWidget *parent) : QDialog(parent)
{
  QLabel *l;
  QGridLayout *layout = new QGridLayout;

  setWindowTitle("Kontenplansuche");
  sWahl="";

  bOk.setText("&Ok");
  bOk.setAutoDefault(true);
  bCancel.setText("&Abbruch");
  bCancel.setAutoDefault(false);
  bAnlegen.setText("A&nlegen");
  bAnlegen.setAutoDefault(false);
  wText.setFixedSize(525,25);
  l=new QLabel("Text");
  layout->addWidget(l,1,1);
  layout->addWidget(&wText,1,2,1,3);
  layout->addWidget(&bOk,2,1);
  layout->addWidget(&bCancel,2,2);
  if (flag_anlegen) layout->addWidget(&bAnlegen,2,3);
  layout->setColumnStretch(4,1);

  wModel.setColumnCount(3);
  wListe.setModel(&wModel);
  wListe.setEnabled(true);
  wListe.setFixedSize(650,300);
  pInitListe();
  layout->addWidget(&wListe,3,1,5,4);

  setLayout(layout);

  connect(&bCancel,SIGNAL(clicked()),this,SLOT(reject()));
  connect(&bOk,SIGNAL(clicked()),this,SLOT(pSuche()));
  connect(&bAnlegen,SIGNAL(clicked()),this,SLOT(pAnlegen()));
  connect(&wListe,SIGNAL(clicked(QModelIndex)),this,SLOT(pAuswahl(QModelIndex)));
}

KplSuche::~KplSuche()
{
  return;
}

int KplSuche::exec(QString suchString)
{
  int r;

  if (suchString.right(1) == "?")
     wText.setText(suchString.left(suchString.length()-1));
  else
     wText.setText(suchString);
  if (wText.text().length()>0) pSuche();
  r=QDialog::exec();
  return(r);
}

void KplSuche::pSuche()
{
  QStandardItem *wItem;
  QSqlQuery      query;
  QString   sTextVgl;
  int       i,wAnz;
  
  pInitListe();
  sTextVgl=SuchName(wText.text().toUpper().simplified().replace("'","`"),"");
  query.exec("SELECT konto,text FROM kontenplan");
  
  for (i=wAnz=0; query.next(); i++)
  {
    if (!SuchName(query.value(1).toString(),"").contains(sTextVgl)) continue;

    wItem=new QStandardItem(query.value(0).toString());
    wItem->setEditable(false),
    wModel.setItem(wAnz,0,wItem);
    wItem=new QStandardItem(query.value(1).toString());
    wItem->setEditable(false),
    wModel.setItem(wAnz,1,wItem);
    wAnz++;
  }

  wModel.setRowCount(wAnz);
  return;
}

void KplSuche::pAuswahl(QModelIndex i)
{
  int wZeile = i.row();

  sWahl=wModel.item(wZeile,0)->text();
  accept();
}

QString KplSuche::auswahl()
{
  return(sWahl);
}

void KplSuche::pInitListe()
{
  wModel.clear();
  wModel.setHorizontalHeaderLabels(QString("Konto,Text").split(","));
  wListe.setColumnWidth(0,95);
  wListe.setColumnWidth(1,500);
}

void KplSuche::pAnlegen()
{
  int r;
  Kontenplan pDiag(true);
  if (pDiag.exec() == QDialog::Accepted)
  {
    sWahl=pDiag.angelegt();
    accept();
  }
}
