#ifndef MITGLIEDER_H
#define MITGLIEDER_H

#include <QtGui>
#include "wadresse.h"
#include "wbank.h"
#include "wgliederung.h"
#include "wmitglied.h"

class Mitglieder : public QDialog
{
  Q_OBJECT

public:
  Mitglieder(bool flag_anlegen=false, QWidget *parent = NULL);
  ~Mitglieder();
  int exec();
  int angelegt();

protected:
  void closeEvent(QCloseEvent *e);
  void keyPressEvent(QKeyEvent *e);

private:
  QLineEdit   *wIntern,*wTel,*wNation;
  QPushButton *bOk,*bCancel,*bDel,*bMitglied,*bZuwend;
  QComboBox   *wSex,*wZahlart,*wZahlStatus;
  QDateEdit   *wGebdat,*wEintritt,*wAustritt,*wBezahlt,*wStatusDatum;
  QDoubleSpinBox *wBeitrag;
  WAdresse    *wAdresse;
  WBank       *wBank;
  WGliederung *wGliederung,*wWohnGliederung;
  WMitglied   *wMid;
  bool fWahl,fAnlegen;
  int  iMid,iIntern,iNeuNummer;
  qint64 iBeitrag;
  QString sMid,sIntern,sTel,sGliederung,sWohnGliederung,sGebdat,sSex,sZahlart;
  QString sBeitrag,sNation,sEintritt,sAustritt,sBezahlt,sZahlStatus;
  QString sStatusDatum;
  QString cMid;
  QTableView *wListe;
  QStandardItemModel *wModel;

private:
  void pSetWahl(bool flag_wahl);
  void pFelder();
  void pFuellListe();
  void pDelete1();

private slots:
  void pCancel();
  void pRead();
  void pWrite();
  void pDelete();
  void pMitglied();
  void pZuwend();
};

#endif
