#include <QtGui>
#include <QtSql>
#include "save.h"

void _SaveDirParam(QFileDialog *wDiag, bool flag_write)
{
  QSqlQuery query;

  if (flag_write)
  {
    query.exec("UPDATE parameter SET wert='" + wDiag->directory().absolutePath()
               + "' WHERE key='Save/Directory'");
    if (query.numRowsAffected()<1)
    {
      query.exec("INSERT INTO parameter (key,wert) VALUES ('Save/Directory','" +
                  wDiag->directory().absolutePath() + "')");
    }
  }
  else
  {
    query.exec("SELECT wert FROM parameter WHERE key='Save/Directory'");
    if (query.next())
    {
      wDiag->setDirectory(query.value(0).toString());
      query.finish();
    }
    wDiag->setDefaultSuffix(".sav");
    wDiag->setNameFilters(QString("Save file (*.sav),Any files (*)").split(","));
    wDiag->selectNameFilter("*.sav");
  }
}

void SaveSave()
{
  bool    flag_ok;
  QString sDatei;
  QFileDialog wDiag;
  QSqlDatabase wDb=QSqlDatabase::database();
  QString sAlt=wDb.databaseName();
  QString sDirAlt,sNameAlt;

  sDirAlt=QFileInfo(sAlt).dir().absolutePath();
  sNameAlt=QFileInfo(sAlt).fileName();

  _SaveDirParam(&wDiag,false);
  wDiag.setConfirmOverwrite(true);
  wDiag.setFileMode(QFileDialog::AnyFile);
  wDiag.setAcceptMode(QFileDialog::AcceptSave);
  wDiag.selectFile(sNameAlt + "." + QDate::currentDate().toString("yyyy-MM-dd")
                   + ".sav");
  if (wDiag.exec() == QDialog::Accepted)
  {
    sDatei=wDiag.selectedFiles()[0];
    if (QFileInfo(sDatei).absoluteFilePath() ==
        QFileInfo(sAlt).absoluteFilePath())
    {
      QMessageBox::critical(NULL,"Datensicherung",
                            "Sichern auf sich selbst ist nicht erlaubt");
      return;
    }
    _SaveDirParam(&wDiag,true);
    wDb.close();
    if (QFile::exists(sDatei)) QFile::remove(sDatei);
    if (!QFile::copy(sAlt,sDatei))
    {
      QMessageBox::critical(NULL,"Datensicherung","Fehler beim Kopieren");
      flag_ok=wDb.open();
    }
    else
    {
      QMessageBox::information(NULL,"Datensicherung","Fertig");
      flag_ok=wDb.open();
    }
    if (!flag_ok)
    {
      QMessageBox::critical(NULL,"Datensicherung","Datenbank nicht mehr ansprechbar! Manuelles eingreifen erforderlich!");
      exit(1);
    }
  }
  return;
}

void SaveRestore()
{
  QSqlDatabase wDb=QSqlDatabase::database();
  QString      sAlt=wDb.databaseName();
  QFileDialog  wDiag;
  QString      sDatei;
  bool         flag_ok;

  _SaveDirParam(&wDiag,false);
  wDiag.setFileMode(QFileDialog::ExistingFile);
  wDiag.setAcceptMode(QFileDialog::AcceptOpen);
  if (wDiag.exec() == QDialog::Accepted)
  {
    sDatei=wDiag.selectedFiles()[0];
    if (QFileInfo(sDatei).absoluteFilePath() ==
        QFileInfo(sAlt).absoluteFilePath())
    {
      QMessageBox::critical(NULL,"Datensicherung",
                            "Sichern auf sich selbst ist nicht erlaubt");
      return;
    }
    _SaveDirParam(&wDiag,write);
    if (QMessageBox::question(NULL,"Datensicherung",
         "Achtung: Durch die Wiederherstellung werden\nalle bestehenden Daten unwiederruflich berschrieben!\nDaten aus der Sicherung wiederherstellen?",
        QMessageBox::Ok|QMessageBox::Cancel) == QMessageBox::Ok)
    {
      wDb.close();
      if (QFile::exists(sAlt)) QFile::remove(sAlt);
      if (!QFile::copy(sDatei,sAlt))
      {
        QMessageBox::critical(NULL,"Datenwiederherstellung","Fehler beim Kopieren");
        flag_ok=wDb.open();
      }
      else
      {
        QMessageBox::information(NULL,"Datenwiederherstellung","Fertig");
        flag_ok=wDb.open();
      }
      if (!flag_ok)
      {
        QMessageBox::critical(NULL,"Datensicherung","Datenbank nicht mehr ansprechbar! Manuelles eingreifen erforderlich!");
        exit(1);
      }
    }
  }
  return;
}
