#include "smtp.h"
#include <QtSql>

Smtp::Smtp()
{
  QString    sUser,sPasswd;
  QByteArray ba;
  QSqlQuery  query;

  wBufLen=0;
  wSendStat=0;
  wTimer.stop();

  wFrom="";
  wFromName="";
  wMailServer="";
  wMailPort=25;
  wAuth="";
  sUser="";
  sPasswd="";
  query.exec("SELECT key,wert FROM parameter WHERE key>='Mail/' AND key<'Mail0'");
  while (query.next())
  {
    if (query.value(0).toString()=="Mail/Host")
       wMailServer=query.value(1).toString();
    else if (query.value(0).toString()=="Mail/Port")
       wMailPort=query.value(1).toInt();
    else if (query.value(0).toString()=="Mail/Abs")
       wFrom=query.value(1).toString();
    else if (query.value(0).toString()=="Mail/Name")
       wFromName=query.value(1).toString();
    else if (query.value(0).toString()=="Mail/User")
       sUser=query.value(1).toString();
    else if (query.value(0).toString()=="Mail/Passwd")
       sPasswd=query.value(1).toString();
  }

  if (sUser.length()>0)
  {
    ba.clear();
    ba.append("",1);
    ba.append(sUser);
    ba.append("",1);
    ba.append(sPasswd);
    wAuth=QString(ba.toBase64());
  }

  connect(&wTimer,SIGNAL(timeout()),this,SLOT(pTimeOut()));
  connect(&wSock,SIGNAL(connected()),this,SLOT(pConnected()));
  connect(&wSock,SIGNAL(disconnected()),this,SLOT(pDisconnected()));
  connect(&wSock,SIGNAL(error(QAbstractSocket::SocketError)),this,SLOT(pError()));
  connect(&wSock,SIGNAL(readyRead()),this,SLOT(pData()));
}

Smtp::~Smtp()
{
}

void Smtp::setTo(QString wAdresse)
{
  wTo=wAdresse;
}

bool Smtp::setText(QString lBaustein, QString adrArt, QString adrKey,
           int lMid, int lJahr, qint64 lCent)
{
  QSqlQuery  query;
  int        l;
  QString    wKonto,wBank,wBlz;

  iMid=lMid;

  query.exec("SELECT subject,inhalt FROM textbaustein WHERE bez='" +
              lBaustein + "'");
  if (!query.next())
  {
    return(false);
  }
  wSubject=query.value(0).toString();
  wText=query.value(1).toString();
  query.finish();

  query.exec("select nummer,blz,bank FROM bankverbindung WHERE art='" +
              adrArt + "' AND key='" + adrKey + "'");
  if (query.next())
  {
    wKonto="XXXXX" + query.value(0).toString().right(4);
    wBlz=query.value(1).toString();
    wBank=query.value(2).toString();
    query.finish();
  }
  else
  {
    wKonto="";
    wBlz="";
    wBank="";
  }

  query.exec("select name2,name1,strasse,plz,ort,land,mail FROM adresse WHERE art='"
              + adrArt + "' AND key='" + adrKey + "'");
  if (!query.next())
  {
    return(false);
  }
  wTo=query.value(6).toString();
  wSubject=wSubject.replace("%vname%",query.value(0).toString())
                   .replace("%nname%",query.value(1).toString())
                   .replace("%mid%",QString::number(iMid))
                   .replace("%strasse%",query.value(2).toString())
                   .replace("%plz%",query.value(3).toString())
                   .replace("%ort%",query.value(4).toString())
                   .replace("%land%",query.value(5).toString())
                   .replace("%jahr%",QString::number(lJahr))
                   .replace("%betrag%",QLocale::system().toString((double)lCent/(double)100.0,'f',2))
                   .replace("%kontonr%",wKonto)
                   .replace("%kontoblz%",wBlz)
                   .replace("%kontobank%",wBank);
  wText=wText.replace("%vname%",query.value(0).toString())
             .replace("%nname%",query.value(1).toString())
             .replace("%mid%",QString::number(iMid))
             .replace("%strasse%",query.value(2).toString())
             .replace("%plz%",query.value(3).toString())
             .replace("%ort%",query.value(4).toString())
             .replace("%land%",query.value(5).toString())
             .replace("%jahr%",QString::number(lJahr))
             .replace("%betrag%",QLocale::system().toString((double)lCent/(double)100.0,'f',2))
             .replace("%kontonr%",wKonto)
             .replace("%kontoblz%",wBlz)
             .replace("%kontobank%",wBank);
  query.finish();

  return true;
}

bool Smtp::sendMail()
{
  int i;

  wSendStat=0;
  wBufLen=0;
  flag_fehler=false;
  wSock.connectToHost(wMailServer,wMailPort);
  while(wSendStat<99)
  {
    usleep(100000);
    QCoreApplication::processEvents();
  }
  if (wSock.state() != QAbstractSocket::UnconnectedState)
  {
     wSock.disconnectFromHost();
     for (i=0; i<600 && wSock.state() != QAbstractSocket::UnconnectedState; i++)
     {
       usleep(100000);
       QCoreApplication::processEvents();
     }
  }
  return(!flag_fehler);
}

void Smtp::pConnected()
{
  wSendStat=1;
  wTimer.start(60000);
}

void Smtp::pDisconnected()
{
  if (wSendStat<90)
  {
     flag_fehler=true;
  }
  wSendStat=99;
}

void Smtp::pError()
{
  if (wSendStat<90)
  {
    wSendStat=99;
    flag_fehler=true;
  }
}

void Smtp::pData()
{
  int l,i,wMsgNr;
  char *sc;
  QString s;

  if (wBufLen>=sizeof(wBuf))
  { // Darf eigentlich nicht vorkommen -> Die Daten bei SMTP sind kurz
    if (wSendStat<90)
    {
      wSendStat=99;
      flag_fehler=true;
    }
    return;
  }
  l=wSock.read(wBuf+wBufLen,sizeof(wBuf)-wBufLen);
  if (l<0)
  {
    pError();
    return;
  }
  wBufLen+=l;
  l=0;
  wMsgNr=-1;

  while(l<wBufLen && wMsgNr<0)
  {
    for (i=l; i<wBufLen && wBuf[i]!='\n'; i++);
    if (i<wBufLen)
    {
      if ((i-l)>=4 && isdigit(wBuf[l]) && isdigit(wBuf[l+1]) &&
          isdigit(wBuf[l+2]) && wBuf[l+3]!='-')
      {
        wMsgNr=100*((int)(wBuf[l  ]-'0')) +
                10*((int)(wBuf[l+1]-'0')) +
                   ((int)(wBuf[l+2]-'0'));
      }
    }
    l=i+1;
  }
  if (wMsgNr>=0)
  {
    switch(wSendStat)
    {
      case 1: // HELO erwartet
              if (wMsgNr!=220)
              {
                flag_fehler=true; wSendStat=90;
                break;
              }
              if (wAuth.length()>0)
              {
                 s="EHLO ";
                 wSendStat=2;
              }
              else
              {
                 s="HELO ";
                 wSendStat=3;
              }
              i=wFrom.indexOf("@");
              if (i>0) s=s+wFrom.mid(i+1);
              s=s+"\r\n";
              sc=s.toAscii().data();
              wSock.write(sc,strlen(sc));
              break;
      case 2: // AUTH erwartet
              if (wMsgNr!=250)
              {
                flag_fehler=true; wSendStat=90;
                break;
              }
              s="AUTH PLAIN " + wAuth + "\r\n";
              sc=s.toAscii().data();
              wSock.write(sc,strlen(sc));
              wSendStat=3;
              break;
      case 3: // MAIL erwartet
              if (wMsgNr!=250 && wMsgNr!=235)
              {
                flag_fehler=true; wSendStat=90;
                break;
              }
              s="MAIL From:<" + wFrom + ">\r\n";
              sc=s.toAscii().data();
              wSock.write(sc,strlen(sc));
              wSendStat=4;
              break;
      case 4: // RCPT erwartet
              if (wMsgNr!=250)
              {
                flag_fehler=true; wSendStat=90;
                break;
              }
              s="RCPT To:<" + wTo + ">\r\n";
              sc=s.toAscii().data();
              wSock.write(sc,strlen(sc));
              wSendStat=5;
              break;
      case 5: // DATA erwartet
              if (wMsgNr!=250)
              {
                flag_fehler=true; wSendStat=90;
                break;
              }
              s="DATA\r\n";
              sc=s.toAscii().data();
              wSock.write(sc,strlen(sc));
              wSendStat=6;
              break;
      case 6: // Eigentliche Mail erwartet
              if (wMsgNr!=354)
              {
                flag_fehler=true; wSendStat=90;
                break;
              }
              pMailText();
              s=".\r\n";
              sc=s.toAscii().data();
              wSock.write(sc,strlen(sc));
              wSendStat=7;
              break;
      case 7: // Mail ist geschickt
              if (wMsgNr!=250)
              {
                flag_fehler=true; wSendStat=90;
                break;
              }
              wSendStat=90;
              break;
    }
    wBufLen=0;
  }
  // Verbindungsende anfordern
  if (wSendStat==90)
  {
    s="QUIT\r\n";
    sc=s.toAscii().data();
    wSock.write(sc,strlen(sc));
    wSendStat=91;
  }
  wTimer.start(60000);
}

void Smtp::pWrHeader(QString wZeile, int wQuoteStart, int wQuoteEnd)
{
  QString s;
  int     i,j,l,l1,p,wVon,wBis,c;
  char    *sc;
  char    wZwiBuf[512];

  sc=wZeile.toLatin1().data();
  l=strlen(sc);
  if (wQuoteStart<0 || wQuoteStart>72) wVon=72;
  else                                 wVon=wQuoteStart;
  if (wQuoteEnd  <1 || wQuoteEnd  > l) wBis=l;
  else                                 wBis=wQuoteEnd;

  for (i=wVon; i<wBis && sc[i] >= ' ' && sc[i] <= 'z'; i++);

  if (i>=wBis)
  { // Kein Sonderzeichen gefunden, also direkt raus
    i=p=0;
    while(i<l)
    { // in 72-er Schritten Header-Zeile aufbauen
      if (p>0) memset(wZwiBuf,' ',p);
      if (strlen(sc+i) < (72-p))
         l1=strlen(sc+i);
      else
      {
         l1=72-p;
         for (j=i+l1-1; j>i && sc[j]!=' '; j--);
         for (; j>i && sc[j]==' '; j--);
         j++;
         if ((j-i) > 40) l1=j-i;
      }
      memcpy(wZwiBuf+p,sc+i,l1);
      p+=l1;
      wZwiBuf[p++]='\r';
      wZwiBuf[p++]='\n';
      wZwiBuf[p]=0;
      wSock.write(wZwiBuf,p);
      i+=l1;
      for (;sc[i]==' '; i++);
      p=8;
    }
    return;
  }
  // Mit Sonderzeichen!
  if (wVon>0) memcpy(wZwiBuf,sc,wVon);
  i=wVon;
  p=wVon;
  if (i>58)
  {
    if (wZwiBuf[p-1]==' ')
    {
      if (i>0) i--;
      while(p>0 && wZwiBuf[p-1]==' ') p--;
      if (p>0)
      {
        wZwiBuf[p++]='\r';
        wZwiBuf[p++]='\n';
        wZwiBuf[p]  =0;
        wSock.write(wZwiBuf,p);
        p=8;
        memset(wZwiBuf,' ',p);
      }
    }
  }
  while(i<wBis)
  {
    strcpy(wZwiBuf+p,"=?iso-8859-1?Q?"); p+=15;
    for (; i<wBis && p<68; i++)
    {
      if (sc[i]< ' ' || sc[i] >'z' || sc[i]=='(' || sc[i]==')' ||
          sc[i]=='<' || sc[i]=='>' || sc[i]=='@' || sc[i]==',' ||
          sc[i]==';' || sc[i]==':' || sc[i]=='"' || sc[i]=='/' ||
          sc[i]=='[' || sc[i]==']' || sc[i]=='?' || sc[i]=='.' ||
          sc[i]=='=' || sc[i]==' ')
      {
        c=sc[i]; if (c<0) c+=256;
        wZwiBuf[p++]='=';
        sprintf(wZwiBuf+p,"%02X",c); 
        p+=2;
      }
      else
        wZwiBuf[p++]=sc[i];
    }
    wZwiBuf[p++]='?';
    wZwiBuf[p++]='=';
    wZwiBuf[p++]='\r';
    wZwiBuf[p++]='\n';
    wZwiBuf[p  ]=0;
    wSock.write(wZwiBuf,p);
    p=8;
    memset(wZwiBuf,' ',p);
  }
  if (i<l)
  {
    if ((l-i) > 500)
       l=500;
    else
       j=l-i;
    memcpy(wZwiBuf+p,sc+i,j);
    p+=j;
    wZwiBuf[p++]='\r';
    wZwiBuf[p++]='\n';
    wZwiBuf[p  ]=0;
    wSock.write(wZwiBuf,p);
  }
}

void Smtp::pMailText()
{
  QDateTime wJetzt = QDateTime::currentDateTime();
  QString s,sf;
  time_t n,ng;
  struct tm *pTm;
  int  i,l,l1;
  char *sc;

  s="MIME-Version: 1.0\r\n";
  sc=s.toAscii().data();
  wSock.write(sc,strlen(sc));

  s="Message-ID: <" + wJetzt.toString("yyyyMMddhhmmsszzz") + ".pp-mailer." +
     sf.sprintf("%06i",iMid);
  i=wFrom.indexOf("@");
  if (i>0) s=s+wFrom.mid(i);
  s=s+">\r\n";
  sc=s.toAscii().data();
  wSock.write(sc,strlen(sc));
  if (wFromName.length()>0)
  {
     s="From: " + wFromName;
     i=s.length();
     s=s+ " <" + wFrom + ">";
     pWrHeader(s,6,i);
  }
  else
  {
     s="From: " + wFrom + "\r\n";
     sc=s.toAscii().data();
     wSock.write(sc,strlen(sc));
  }
  s="To: " + wTo + "\r\n";
  sc=s.toAscii().data();
  wSock.write(sc,strlen(sc));
  s="Date: ";
  switch(wJetzt.date().dayOfWeek())
  { // Nicht die QT-Funktion nehmen, da nicht lokalisiert werden darf
    case 1: s=s+"Mon"; break;
    case 2: s=s+"Tue"; break;
    case 3: s=s+"Wed"; break;
    case 4: s=s+"Thu"; break;
    case 5: s=s+"Fri"; break;
    case 6: s=s+"Sat"; break;
    case 7: s=s+"Sun"; break;
  }
  s=s+", " + wJetzt.toString("dd") + " ";
  switch(wJetzt.date().month())
  { // Nicht die QT-Funktion nehmen, da nicht lokalisiert werden darf
    case  1: s=s+"Jan"; break;
    case  2: s=s+"Feb"; break;
    case  3: s=s+"Mar"; break;
    case  4: s=s+"Apr"; break;
    case  5: s=s+"May"; break;
    case  6: s=s+"Jun"; break;
    case  7: s=s+"Jul"; break;
    case  8: s=s+"Aug"; break;
    case  9: s=s+"Sep"; break;
    case 10: s=s+"Oct"; break;
    case 11: s=s+"Nov"; break;
    case 12: s=s+"Dec"; break;
  }
  s=s+" "+wJetzt.toString("yyyy HH:mm:ss");
  n=time(NULL);
  pTm=gmtime(&n), pTm->tm_isdst=-1;
  i=(n-mktime(pTm))/60;
  if (i!=0)
  {
    if (i<0) { s=s+" -"; i=i*-1; }
    else       s=s+" +";
    s=s+sf.sprintf("%02i%02i",i/60,i%60);
  }
  s=s+"\r\n";

  sc=s.toAscii().data();
  wSock.write(sc,strlen(sc));
  s="X-Mailer:  Piratenpartei Rechnungsmailer\r\n";
  sc=s.toAscii().data();
  wSock.write(sc,strlen(sc));

  if (wSubject.length()>0)
  {
     s="Subject: " + wSubject;
     pWrHeader(s,9,0);
  }

  s="Content-Type: text/plain;\r\n        charset=iso-8859-1\r\n";
  sc=s.toAscii().data();
  wSock.write(sc,strlen(sc));
  s="Content-Transfer-Encoding: 8bit\r\n\r\n";
  sc=s.toAscii().data();
  wSock.write(sc,strlen(sc));

  i=0;
  while(i<wText.length())
  {
    for (l=i; l<wText.length() && (l-i)<76 && wText.mid(l,1)!="\n"; l++);
    if (l<wText.length() && wText.mid(l,1)!=" " && wText.mid(l,1)!="\n")
    {
      for (l1=l; l1>i && wText.mid(l1-1,1)!=" "; l1--);
      if (l1<=i)
      {
        for (l1=l; l1<wText.length() && wText.mid(l1,1)!=" " &&
             wText.mid(l1,1)!="\n"; l1++);
      }
      l=l1;
    }
    for (l1=l; l1>i && wText.mid(l1-1,1)==" "; l1--);
    s=wText.mid(i,l1-i) + "\r\n";
    sc=s.toAscii().data();
    wSock.write(sc,strlen(sc));
    for (i=l; i<wText.length() && wText.mid(i,1)==" "; i++);
    if (i<wText.length() && wText.mid(i,1)=="\n") i++;
  }
}

void Smtp::pTimeOut()
{
  if (wSendStat<90)
  {
    wSendStat=99;
    flag_fehler=true;
  }
}
