#include <QtGui>
#include <QtSql>

#include "spendenparam.h"
#include "wkonto.h"
#include "utils.h"

SpendenParam::SpendenParam(QWidget *parent) : QDialog(parent)
{
  QLabel *l;
  int    z;
  QGridLayout *layout = new QGridLayout;
  QHBoxLayout *buttonLayout = new QHBoxLayout;

  setWindowTitle("Spenden - Parameter");

  wArt.insertItem(0,"");
  wArt.insertItem(1,"Zweckgebundene Geldspende");
  wArt.insertItem(2,"Allgemeine Geldspende");
  wArt.insertItem(3,"Aufwandsspende");
  wArt.insertItem(4,"Sachspende");
  wArt.insertItem(5,"Mitgliedsbeitrag");
  wArt.insertItem(6,"Mandatstrgerbeitrag");
  wArt.setFixedSize(wArt.sizeHint());

  pProzBox(&wProzInt);
  pProzBox(&wProzBuv);
  pProzBox(&wProzLv);
  pProzBox(&wProzBzv);
  pProzBox(&wProzKv);
  pProzBox(&wProzOv);

  wKostK.setFixedSize(200,25);
  wKostB.setFixedSize(200,25);
  wKostAnonK.setFixedSize(200,25);
  wKostAnonB.setFixedSize(200,25);
  wKostJurK.setFixedSize(200,25);
  wKostJurB.setFixedSize(200,25);
  wKtoK    =new WKonto(&lKtoK,true,this);
  wKtoB    =new WKonto(&lKtoB,true,this);
  wKtoAnonK=new WKonto(&lKtoAnonK,true,this);
  wKtoAnonB=new WKonto(&lKtoAnonB,true,this);
  wKtoJurK =new WKonto(&lKtoJurK,true,this);
  wKtoJurB =new WKonto(&lKtoJurB,true,this);
  lKtoK.setFixedSize(450,25);
  lKtoB.setFixedSize(450,25);
  lKtoAnonK.setFixedSize(450,25);
  lKtoAnonB.setFixedSize(450,25);
  lKtoJurK.setFixedSize(450,25);
  lKtoJurB.setFixedSize(450,25);

  wMIDBuchung.setText("Buchung auf &Mitgliederkonto");

  bLesen.setText("&Lesen");
  bOk.setText("&Speichern");
  bCancel.setText("&Abbruch");
  bLesen.setAutoDefault(false);
  bOk.setAutoDefault(false);
  bCancel.setAutoDefault(false);

  z=1;

  l=new QLabel("Art");
  layout->addWidget(l,z,1);
  layout->addWidget(&wArt,z,2);
  layout->addWidget(&bLesen,z,3);
  z++;

  l=new QLabel("Anteile:");
  layout->addWidget(l,z,1);
  z++;
  l=new QLabel("Ortsverband");
  layout->addWidget(l,z,1);
  layout->addWidget(&wProzOv,z,2);
  l=new QLabel("Kreisverband");
  layout->addWidget(l,z,3);
  layout->addWidget(&wProzKv,z,4);
  l=new QLabel("Bezirksverband");
  layout->addWidget(l,z,6);
  layout->addWidget(&wProzBzv,z,7);
  z++;
  l=new QLabel("Landesverband");
  layout->addWidget(l,z,1);
  layout->addWidget(&wProzLv,z,2);
  l=new QLabel("Bundesverband");
  layout->addWidget(l,z,3);
  layout->addWidget(&wProzBuv,z,4);
  l=new QLabel("International");
  layout->addWidget(l,z,6);
  layout->addWidget(&wProzInt,z,7);
  z++;

  layout->addWidget(&wMIDBuchung,z,1,1,2);
  z++;

  l=new QLabel("Kost.");
  layout->addWidget(l,z,2);
  l=new QLabel("Konto");
  layout->addWidget(l,z,3);
  z++;

  l=new QLabel("Kasse");
  layout->addWidget(l,z,1);
  layout->addWidget(&wKostK,z,2);
  layout->addWidget(wKtoK,z,3);
  layout->addWidget(&lKtoK,z,4,1,4);
  z++;
  l=new QLabel("Bank");
  layout->addWidget(l,z,1);
  layout->addWidget(&wKostB,z,2);
  layout->addWidget(wKtoB,z,3);
  layout->addWidget(&lKtoB,z,4,1,4);
  z++;
  l=new QLabel("Anonym Kasse");
  layout->addWidget(l,z,1);
  layout->addWidget(&wKostAnonK,z,2);
  layout->addWidget(wKtoAnonK,z,3);
  layout->addWidget(&lKtoAnonK,z,4,1,4);
  z++;
  l=new QLabel("Anonym Bank");
  layout->addWidget(l,z,1);
  layout->addWidget(&wKostAnonB,z,2);
  layout->addWidget(wKtoAnonB,z,3);
  layout->addWidget(&lKtoAnonB,z,4,1,4);
  z++;
  l=new QLabel("Jur. Kasse");
  layout->addWidget(l,z,1);
  layout->addWidget(&wKostJurK,z,2);
  layout->addWidget(wKtoJurK,z,3);
  layout->addWidget(&lKtoJurK,z,4,1,4);
  z++;
  l=new QLabel("Jur. Bank");
  layout->addWidget(l,z,1);
  layout->addWidget(&wKostJurB,z,2);
  layout->addWidget(wKtoJurB,z,3);
  layout->addWidget(&lKtoJurB,z,4,1,4);
  z++;

  buttonLayout->addWidget(&bOk);
  buttonLayout->addWidget(&bCancel);
  buttonLayout->addStretch(1);
  layout->addLayout(buttonLayout,z,1,1,7);

  layout->setColumnStretch(5,1);

  setLayout(layout);

  pSetWahl(true);

  connect(&bCancel,SIGNAL(clicked()),this,SLOT(pCancel()));
  connect(&bOk,SIGNAL(clicked()),this,SLOT(pWrite()));
  connect(&bLesen,SIGNAL(clicked()),this,SLOT(pRead()));
}

SpendenParam::~SpendenParam()
{
  delete wKtoK;
  delete wKtoB;
  delete wKtoAnonK;
  delete wKtoAnonB;
  delete wKtoJurK;
  delete wKtoJurB;
}

void SpendenParam::pSetWahl(bool flag_wahl)
{
  fWahl=flag_wahl;
  wArt.setEnabled(flag_wahl);
  bLesen.setEnabled(flag_wahl);
  
  wProzInt.setEnabled(!flag_wahl);
  wProzBuv.setEnabled(!flag_wahl);
  wProzLv.setEnabled(!flag_wahl);
  wProzBzv.setEnabled(!flag_wahl);
  wProzKv.setEnabled(!flag_wahl);
  wProzOv.setEnabled(!flag_wahl);
  wMIDBuchung.setEnabled(!flag_wahl);
  wKtoK->setEnabled(!flag_wahl);
  wKtoB->setEnabled(!flag_wahl);
  wKtoAnonK->setEnabled(!flag_wahl);
  wKtoAnonB->setEnabled(!flag_wahl);
  wKtoJurK->setEnabled(!flag_wahl);
  wKtoJurB->setEnabled(!flag_wahl);
  wKostK.setEnabled(!flag_wahl);
  wKostB.setEnabled(!flag_wahl);
  wKostAnonK.setEnabled(!flag_wahl);
  wKostAnonB.setEnabled(!flag_wahl);
  wKostJurK.setEnabled(!flag_wahl);
  wKostJurB.setEnabled(!flag_wahl);
  bOk.setEnabled(!flag_wahl);
  bCancel.setEnabled(!flag_wahl);

  if (flag_wahl)
  {
    wArt.setCurrentIndex(0);
    wProzInt.setValue(0.0l);
    wProzBuv.setValue(0.0l);
    wProzLv.setValue(0.0l);
    wProzBzv.setValue(0.0l);
    wProzKv.setValue(0.0l);
    wProzOv.setValue(0.0l);
    wMIDBuchung.setCheckState(Qt::Unchecked);
    wKtoK->setText("");
    wKtoB->setText("");
    wKtoAnonK->setText("");
    wKtoAnonB->setText("");
    wKtoJurK->setText("");
    wKtoJurB->setText("");
    wKostK.setText("");
    wKostB.setText("");
    wKostAnonK.setText("");
    wKostAnonB.setText("");
    wKostJurK.setText("");
    wKostJurB.setText("");
  }

  if (flag_wahl)
     wArt.setFocus();
  else if (sKtoK.length()<1 && sKtoB.length()<1 && sKtoAnonK.length()<1 &&
           sKtoAnonB.length()<1 && sKtoJurK.length()<1 && sKtoJurB.length()<1)
     wProzOv.setFocus();
  else
     bCancel.setFocus();
}

void SpendenParam::pFelder()
{
  switch(wArt.currentIndex())
  {
    case 1: sArt="Z"; break;
    case 2: sArt="G"; break;
    case 3: sArt="A"; break;
    case 4: sArt="S"; break;
    case 5: sArt="M"; break;
    case 6: sArt="T"; break;
    default: sArt=""; break;
  }
  sProzInt=QString::number((qint64)round(wProzInt.value()*(double)100.0l));
  sProzBuv=QString::number((qint64)round(wProzBuv.value()*(double)100.0l));
  sProzLv=QString::number((qint64)round(wProzLv.value()*(double)100.0l));
  sProzBzv=QString::number((qint64)round(wProzBzv.value()*(double)100.0l));
  sProzKv=QString::number((qint64)round(wProzKv.value()*(double)100.0l));
  sProzOv=QString::number((qint64)round(wProzOv.value()*(double)100.0l));
  if (wMIDBuchung.checkState() == Qt::Checked)
     sMIDBuchung="J";
  else
     sMIDBuchung="N";
  sKtoK=wKtoK->text().simplified().toUpper().replace("'","`");
  sKtoB=wKtoB->text().simplified().toUpper().replace("'","`");
  sKtoAnonK=wKtoAnonK->text().simplified().toUpper().replace("'","`");
  sKtoAnonB=wKtoAnonB->text().simplified().toUpper().replace("'","`");
  sKtoJurK=wKtoJurK->text().simplified().toUpper().replace("'","`");
  sKtoJurB=wKtoJurB->text().simplified().toUpper().replace("'","`");
  sKostK=wKostK.text().simplified().replace("'","`");
  sKostB=wKostB.text().simplified().replace("'","`");
  sKostAnonK=wKostAnonK.text().simplified().replace("'","`");
  sKostAnonB=wKostAnonB.text().simplified().replace("'","`");
  sKostJurK=wKostJurK.text().simplified().replace("'","`");
  sKostJurB=wKostJurB.text().simplified().replace("'","`");
}

void SpendenParam::pRead()
{
  QSqlQuery query;

  if (!fWahl) return;
  pFelder();
  if (sArt=="") return;

  query.exec("SELECT prozint,prozbuv,prozlv,prozbzv,prozkv,prozov,midbuchung,kontokasse,kontobank,kontoanonkasse,kontoanonbank,kontojurkasse,kontojurbank,kostkasse,kostbank,kostanonkasse,kostanonbank,kostjurkasse,kostjurbank FROM spendenparam WHERE art='" + sArt + "'");
  if (query.next())
  {
    wProzInt.setValue(query.value(0).toDouble()/100.0l);
    wProzBuv.setValue(query.value(1).toDouble()/100.0l);
    wProzLv.setValue(query.value(2).toDouble()/100.0l);
    wProzBzv.setValue(query.value(3).toDouble()/100.0l);
    wProzKv.setValue(query.value(4).toDouble()/100.0l);
    wProzOv.setValue(query.value(5).toDouble()/100.0l);
    if (query.value(6).toString() == "J")
       wMIDBuchung.setCheckState(Qt::Checked);
    else
       wMIDBuchung.setCheckState(Qt::Unchecked);
    wKtoK->setText(query.value(7).toString());
    wKtoB->setText(query.value(8).toString());
    wKtoAnonK->setText(query.value(9).toString());
    wKtoAnonB->setText(query.value(10).toString());
    wKtoJurK->setText(query.value(11).toString());
    wKtoJurB->setText(query.value(12).toString());
    wKostK.setText(query.value(13).toString());
    wKostB.setText(query.value(14).toString());
    wKostAnonK.setText(query.value(15).toString());
    wKostAnonB.setText(query.value(16).toString());
    wKostJurK.setText(query.value(17).toString());
    wKostJurB.setText(query.value(18).toString());
  }

  pFelder();
  pSetWahl(false);
}

void SpendenParam::pCancel()
{
  if (fWahl)
    close();
  else
  {
    pSetWahl(true);
  }
}

void SpendenParam::pWrite()
{
  QSqlQuery query;
  QString q;

  if (fWahl) return;
  pFelder();
  if (sKtoK.length()<1 && sKtoB.length()<1 && sKtoAnonK.length()<1 &&
      sKtoAnonB.length()<1 && sKtoJurK.length()<1 && sKtoJurB.length()<1)
  {
    wKtoK->setFocus();
    return;
  }

  query.exec("UPDATE spendenparam SET prozint='" + sProzInt +
              "',prozbuv='" + sProzBuv + "',prozlv='" + sProzLv +
              "',prozbzv='" + sProzBzv + "',prozkv='" + sProzKv +
              "',prozov='" + sProzOv + "',midbuchung='" + sMIDBuchung +
              "',kontokasse='" + sKtoK + "',kontobank='" + sKtoB +
              "',kontoanonkasse='" + sKtoAnonK +
              "',kontoanonbank='" + sKtoAnonB +
              "',kontojurkasse='" + sKtoJurK +
              "',kontojurbank='"  + sKtoJurB +
              "',kostkasse='" + sKostK + "',kostbank='" + sKostB +
              "',kostanonkasse='" + sKostAnonK +
              "',kostanonbank='"  + sKostAnonB +
              "',kostjurkasse='"  + sKostJurK +
              "',kostjurbank='"   + sKostJurB +
              "' WHERE art='" + sArt + "'");
  if (query.numRowsAffected()<1)
  {
    query.exec("INSERT INTO spendenparam (art,prozint,prozbuv,prozlv,prozbzv,prozkv,prozov,midbuchung,kontokasse,kontobank,kontoanonkasse,kontoanonbank,kontojurkasse,kontojurbank,kostkasse,kostbank,kostanonkasse,kostanonbank,kostjurkasse,kostjurbank) VALUES ('" +
               sArt       + "','" + sProzInt    + "','" + sProzBuv   + "','" +
               sProzLv    + "','" + sProzBzv    + "','" + sProzKv    + "','" +
               sProzOv    + "','" + sMIDBuchung + "','" + sKtoK      + "','" +
               sKtoB      + "','" + sKtoAnonK   + "','" + sKtoAnonB  + "','" +
               sKtoJurK   + "','" + sKtoJurB    + "','" + sKostK     + "','" +
               sKostB     + "','" + sKostAnonK  + "','" + sKostAnonB + "','" +
               sKostJurK  + "','" + sKostJurB   + "')");
  }
  pSetWahl(true);
}

void SpendenParam::closeEvent(QCloseEvent *e)
{
  if (fWahl)
    e->accept();
  else
  {
    pCancel();
    e->ignore();
  }
}

void SpendenParam::keyPressEvent(QKeyEvent *e)
{
  if (e->key()==Qt::Key_Escape)
  {
    if (fWahl)
       close();
    else
       pCancel();
    e->ignore();
  }
  e->accept();
}

void SpendenParam::pProzBox(QDoubleSpinBox *wBox)
{
  wBox->setDecimals(2);
  wBox->setMinimum(0.00);
  wBox->setMaximum(100.00);
  wBox->setAlignment(Qt::AlignVCenter | Qt::AlignRight);
  wBox->setFixedSize(100,25);
  wBox->setSuffix(" %");
  wBox->setValue(0.0);
}
