#include <stdio.h>
#include <stdlib.h>
#include <QMessageBox>
#include <QtSql>
#include <QtCore>

#include "utils.h"

static bool    _flag_init=false;
static QString _sPrefGliederung,_sPrefMitglied,_sPrefLief;
static QString _sGliederung,_sAbgrAktiv,_sAbgrPassiv,_sBankGeb;
static QString _sSpendeAdr1,_sSpendeAdr2,_sSpendeAdr3;
static QString _sSpendeOrt,_sSpendeFunkt,_sSpendeAbs;
static int     _iAddMitglied,_iBeitragAb,_iGliederungEbene;
static qint64  _iSpendeMin;

void UtilInit(bool flag_force)
{
  QSqlQuery query;

  if (flag_force || !_flag_init)
  {
    query.exec("SELECT key,wert FROM parameter");
    while(query.next())
    {
      if (query.value(0).toString()=="General/Gliederung")
         _sGliederung=query.value(1).toString();
      else if (query.value(0).toString()=="General/BeitragAb")
      {
        if (query.value(1).toString()=="J")
           _iBeitragAb=1;
        else if (query.value(1).toString()=="X")
           _iBeitragAb=2;
        else
           _iBeitragAb=0;
      }
      else if (query.value(0).toString()=="Konten/AbgrAktiv")
         _sAbgrAktiv=query.value(1).toString();
      else if (query.value(0).toString()=="Konten/AbgrPassiv")
         _sAbgrPassiv=query.value(1).toString();
      else if (query.value(0).toString()=="Konten/BankGeb")
         _sBankGeb=query.value(1).toString();
      else if (query.value(0).toString()=="Konten/PrefMitglied")
         _sPrefMitglied=query.value(1).toString();
      else if (query.value(0).toString()=="Konten/AddMitglied")
         _iAddMitglied=query.value(1).toInt();
      else if (query.value(0).toString()=="Konten/PrefGliederung")
         _sPrefGliederung=query.value(1).toString();
      else if (query.value(0).toString()=="Konten/PrefLief")
         _sPrefLief=query.value(1).toString();
      else if (query.value(0).toString()=="Spende/Adr1")
         _sSpendeAdr1=query.value(1).toString();
      else if (query.value(0).toString()=="Spende/Adr2")
         _sSpendeAdr2=query.value(1).toString();
      else if (query.value(0).toString()=="Spende/Adr3")
         _sSpendeAdr3=query.value(1).toString();
      else if (query.value(0).toString()=="Spende/Abs")
         _sSpendeAbs=query.value(1).toString();
      else if (query.value(0).toString()=="Spende/Ort")
         _sSpendeOrt=query.value(1).toString();
      else if (query.value(0).toString()=="Spende/Funkt")
         _sSpendeFunkt=query.value(1).toString();
      else if (query.value(0).toString()=="Spende/Min")
         _iSpendeMin=query.value(1).toLongLong();
    }
    query.finish();
    _iGliederungEbene=0;
    if (_sGliederung.length() > 0)
    {
       query.exec("SELECT ebene FROM verband WHERE namekurz='" +
               _sGliederung + "' LIMIT 1");
       if (query.next())
       {
         _iGliederungEbene=query.value(0).toInt();
         query.finish();
       }
    }
    _flag_init=true;
  }
}

int UtilQDelete()
{
  if (QMessageBox::question(NULL,"Lschen","Soll der Datensatz gelscht werden",
      QMessageBox::Ok|QMessageBox::Cancel,QMessageBox::Ok)==QMessageBox::Ok)
     return(1);
  else
     return(0);
}

int UtilBuch(QDate Datum, int Lfd, QString Kost, QString Beleg, QString Text,
             qint64 Cent, QString Konto, QString GKonto,
             QString Beschluss, QString Art)
{
  QSqlQuery query;
  int       wLfd;
  int       i;
  QString   wArt;
  QDateTime wJetzt = QDateTime::currentDateTime();

  wArt=Art.simplified();
  if (wArt.length()<1)
  {
    if (Konto==_sAbgrAktiv || Konto==_sAbgrPassiv ||
        GKonto==_sAbgrAktiv || GKonto==_sAbgrPassiv)
       wArt="A";
  }

  if (Lfd<1)
  {
    for (i=0; i<10; i++)
    {
      query.exec("SELECT lfd FROM journdat WHERE datum='" +
                 Datum.toString("yyyy-MM-dd") +
                 "' ORDER BY datum DESC,lfd DESC LIMIT 1");
      if (query.next())
	      wLfd=query.value(0).toInt()+1;
      else
	      wLfd=1;
      query.finish();
      if (wLfd>9999) return(-1);
      query.exec("BEGIN TRANSACTION");
      query.exec("INSERT INTO journdat (datum,lfd,kost,beleg,extlfd,butext,erfasst,art,beschluss) VALUES('" +
		      Datum.toString("yyyy-MM-dd") + "','" +
		      QString::number(wLfd)        + "','" +
		      Kost.simplified()            + "','" +
		      Beleg.simplified()           + "','0','" +
		      Text.simplified()            + "','" +
		      wJetzt.toString("yyyy-MM-dd hh:mm:ss") + "','" +
		      wArt + "','" +
                      Beschluss.simplified() + "')");
      if (query.numRowsAffected()>0) break;
      query.exec("ROLLBACK TRANSACTION");
    }
    if (i>=10) return(-1);
  }
  else
  {
    wLfd=Lfd;
    query.exec("SELECT lfd,art FROM journdat WHERE datum='" +
                Datum.toString("yyyy-MM-dd") + "' AND lfd='" +
                QString::number(wLfd) + "' LIMIT 1");
    if (!query.next())
       return(-1);
    if (wArt.length()<1) wArt=query.value(1).toString();
    query.finish();
    query.exec("BEGIN TRANSACTION");
    query.exec("UPDATE journdat SET beleg='" + Beleg.simplified() +
               "',kost='" + Kost.simplified() +
               "',butext='" + Text.simplified() +
               "',art='" + wArt +
               "',beschluss='" + Beschluss.simplified() +
               "' WHERE datum='" + Datum.toString("yyyy-MM-dd") +
               "' AND lfd='" + QString::number(wLfd) + "'");
  }
  query.exec("DELETE FROM kgkto WHERE datum='" +
             Datum.toString("yyyy-MM-dd") + "' AND lfd='" +
             QString::number(wLfd) + "'");
  query.exec("INSERT INTO kgkto (datum,lfd,kg,konto,cent,abstimm) VALUES ('" +
             Datum.toString("yyyy-MM-dd") + "','" +
             QString::number(wLfd)        + "','1','" +
             Konto.simplified().toUpper() + "','" +
             QString::number(Cent)        + "','0')");
  query.exec("INSERT INTO kgkto (datum,lfd,kg,konto,cent,abstimm) VALUES ('" +
             Datum.toString("yyyy-MM-dd")  + "','" +
             QString::number(wLfd)         + "','2','" +
             GKonto.simplified().toUpper() + "','" +
             QString::number(-1 * Cent)    + "','0')");
  query.exec("COMMIT TRANSACTION");
  return(wLfd);
}

QString UtilKtoText(QString Konto)
{
  QSqlQuery query;
  QString   wText,s;
  QString   sKonto;
  int       i;

  UtilInit(false);
  sKonto=Konto.simplified().toUpper().replace("'","`");
  if (sKonto.length()<2) return("");
  query.exec("SELECT text FROM kontenplan WHERE konto='" + sKonto + "'");
  if (query.next())
  {
    wText=query.value(0).toString();
    query.finish();
    return(wText);
  }
  if (_sPrefGliederung=="" ||
      sKonto.left(_sPrefGliederung.length())==_sPrefGliederung)
  {
    query.exec("SELECT namekurz FROM verband WHERE bukto='" +
               sKonto.mid(_sPrefGliederung.length()) + "'");
    if (query.next())
    {
      wText=query.value(0).toString();
      query.finish();
      query.exec("Select name1 FROM adresse WHERE art='V' AND key='" +
                  wText + "'");
      if (query.next())
      {
        wText=query.value(0).toString();
        query.finish();
      }
      return(wText);
    }
  }
  if (_sPrefLief!="" && sKonto.left(_sPrefLief.length())==_sPrefLief &&
      sKonto.length()>_sPrefLief.length())
  {
    query.exec("SELECT bez FROM lieferant WHERE bukto='" +
               sKonto.mid(_sPrefLief.length()) + "'");
    if (query.next())
    {
      s=query.value(0).toString();
      query.finish();
    }
    else
      s=sKonto.mid(_sPrefLief.length());
    query.exec("Select name1 FROM adresse WHERE art='L' AND key='" + s + "'");
    if (query.next())
    {
      wText=query.value(0).toString();
      query.finish();
      return(wText);
    }
  }
  if (_sPrefMitglied=="" ||
      sKonto.left(_sPrefMitglied.length())==_sPrefMitglied)
  {
    i=sKonto.mid(_sPrefMitglied.length()).toInt()-_iAddMitglied;
    if (i>0 && i<999999)
    {
      s=s.sprintf("%08i",i);
      query.exec("SELECT name1,name2 FROM adresse WHERE art='M' AND key='" +
                 s + "'");
      if (query.next())
      {
        wText="MID " + QString::number(i) + " " + query.value(0).toString() +
              ", " + query.value(1).toString();
        return(wText);
        query.finish();
      }
    }
  }
  return("");
}

QDate UtilGJVon()
{
  int   wJahr;
  QDate wDatum = QDate::currentDate();
  wJahr=wDatum.year();
  wDatum.setDate(wJahr,1,1);
  return(wDatum);
}

QDate UtilGJVonDatum(QDate wDat)
{
  QDate wDat1,wDat2;

  wDat2=UtilGJVon();
  wDat1.setDate(wDat.year(),wDat2.month(),wDat2.day());
  if (wDat1>wDat)
  {
    wDat1.setDate(wDat.year() - 1,wDat2.month(),wDat2.day());
  }
  return(wDat1);
}

QString SuchName(QString NName, QString VName)
{
  QByteArray wName = QString(NName + VName).toUpper().toLatin1();
  QByteArray wResult;
  int     i,l;
  char    cVgl,cAlt;

  wResult.clear();
  l=wName.length();
  for (i=0,cVgl=cAlt=0; i<l; i++)
  {
    if (wName[i]!=cVgl)
    {
      cVgl=wName[i];
      switch(cVgl)
      {
        case '': wResult.append("A"); break;
        case '': wResult.append("O"); break;
        case '': wResult.append("U"); break;
        case '': wResult.append("A"); break;
        case '': wResult.append("O"); break;
        case '': wResult.append("U"); break;
        case '': wResult.append("A"); break;
        case 'J': wResult.append("I"); break;
        case 'Y': wResult.append("I"); break;
        default:  if (cVgl>='A' && cVgl<='Z')
                  {
                     if ((cAlt!='A' && cAlt!='E' && cAlt!='U') || cVgl!='E')
                     wResult.append(cVgl);
                  }
      }
    }
    cAlt=cVgl;
  }
  return(QString(wResult));
}

QString UtilSelbst()
{
  UtilInit(false);
  return(_sGliederung);
}

int UtilSelbstEbene()
{
  UtilInit(false);
  return(_iGliederungEbene);
}

QString UtilLsKonto(QString s)
{
  QSqlQuery query;
  QString   s1;

  UtilInit(false);
  query.exec("SELECT bukto FROM lieferant WHERE bez='" +
              s.simplified().replace("'","`").toUpper() + "'");
  if (query.next())
  {
    s1=query.value(0).toString();
    query.finish();
    if (s1.length()<1) s1=s;
  }
  else
    s1=s;
  return(_sPrefLief + s1);
}

QString UtilGlKonto(QString s)
{
  UtilInit(false);
  return(_sPrefGliederung + s);
}

QString UtilMIDKonto(int mid)
{
  UtilInit(false);
  if (mid<0)
     return(_sPrefMitglied);
  else
     return(_sPrefMitglied + QString::number(mid+_iAddMitglied));
}

QString UtilBankGebKonto()
{
  UtilInit(false);
  return(_sBankGeb);
}

int UtilBeitragAb()
{
  UtilInit(false);
  return(_iBeitragAb);
}

QString UtilSpendeAdr(int lfd)
{
  UtilInit(false);
  switch(lfd)
  {
    case 1: return(_sSpendeAdr1); break;
    case 2: return(_sSpendeAdr2); break;
    case 3: return(_sSpendeAdr3); break;
    case 4: return(_sSpendeOrt); break;
    case 5: return(_sSpendeFunkt); break;
    case 6: return(_sSpendeAbs); break;
  }
  return("");
}

qint64 UtilSpendeMin()
{
  UtilInit(false);
  return(_iSpendeMin);
}

static QString _wZahl[13]={"null","eins","zwei","drei","vier","fnf","sechs","sieben","acht","neun","zehn","elf","zwlf"};
static QString _wZehn[8]={"zwanzig","dreiig","vierzig","fnfzig","sechzig","siebzig","achtzig","neunzig"};

QString UtilZahlwortZiffer(QString prefix, int n)
{
  QString wErg;
  int n1=n%1000;

  wErg="";

  if (n1>199)
  {
    wErg=wErg + _wZahl[n1/100] + "hundert";
    n1=n1%100;
  }
  else if (n1>99)
  {
    wErg=wErg + "einhundert";
    n1=n1%100;
  }
  if (n1>19)
  {
    if      ((n1%10)>1)  wErg = wErg + _wZahl[n1%10] + "und";
    else if ((n1%10)!=0) wErg = wErg + "einund";
    wErg=wErg+_wZehn[(n1/10)-2];
  }
  else if (n1>12)
    wErg=wErg + _wZahl[n1%10] + "zehn";
  else if (n1==1 && prefix == "")
    wErg=wErg + "ein";
  else if (n1==1 && prefix == "millionen")
    wErg=wErg + "eine";
  else if (n1>0)
    wErg=wErg + _wZahl[n1];
  wErg = wErg + prefix;

  return(wErg);
}

QString UtilZahlwort(qint64 cent)
{
  int i,n,vk,nk;
  QString wErg;

  wErg="";
  vk=(int)(cent/(qint64)100);
  nk=(int)(cent%(qint64)100);

  n=vk%1000000000;
  if (vk>999999) wErg=wErg+UtilZahlwortZiffer("millionen",n/1000000);
  n=n%1000000;
  if (vk>999)    wErg=wErg+UtilZahlwortZiffer("tausend",n/1000);
  n=n%1000;
  if (vk>0)      wErg=wErg+UtilZahlwortZiffer("",n);
  else           wErg="null";

  if (nk>0)
  {
    wErg=wErg+"komma";
    n=nk%100;
    if (n==10) wErg=wErg+"eins";
    else       wErg=wErg+_wZahl[n/10];
    n=nk%10;
    if (n==1)  wErg=wErg+"eins";
    else       wErg=wErg+_wZahl[n];
  }

  return(wErg.left(1).toUpper() + wErg.mid(1));
}
