#include "wadresse.h"

WAdresse::WAdresse(int flag_name, QWidget *parent)
{
  wParent=parent;

  wName1  =new QLineEdit(parent); wName1->setFixedSize(525,25);
  if (flag_name)
  {
    wName2  =new QLineEdit(parent); wName2->setFixedSize(525,25);
    wName2->setMaxLength(60);
  }
  else
     wName2=NULL;
  wStrasse=new QLineEdit(parent); wStrasse->setFixedSize(525,25);
  wPlz    =new QLineEdit(parent); wPlz->setFixedSize(95,25);
  wOrt    =new QLineEdit(parent); wOrt->setFixedSize(525,25);
  wLand   =new QLineEdit(parent); wLand->setFixedSize(525,25);
  wMail   =new QLineEdit(parent); wMail->setFixedSize(625,25);

  wName1->setMaxLength(60);
  wStrasse->setMaxLength(60);
  wPlz->setMaxLength(10);
  wOrt->setMaxLength(60);
  wLand->setMaxLength(60);
  wMail->setMaxLength(80);
}

WAdresse::~WAdresse()
{
  delete(wName1);
  delete(wName2);
  delete(wStrasse);
  delete(wPlz);
  delete(wOrt);
  delete(wLand);
  delete(wMail);
}

QLineEdit *WAdresse::Name1() { return(wName1); }
QLineEdit *WAdresse::Name2() { return(wName2); }
QLineEdit *WAdresse::Strasse() { return(wStrasse); }
QLineEdit *WAdresse::Plz() { return(wPlz); }
QLineEdit *WAdresse::Ort() { return(wOrt); }
QLineEdit *WAdresse::Land() { return(wLand); }
QLineEdit *WAdresse::Mail() { return(wMail); }

void WAdresse::FuellLayout(QGridLayout *layout, int y, int x)
{
  QLabel *l;
  int i;

  i=y;
  if (wName2!=NULL)
  {
    l=new QLabel("Vorname");
    layout->addWidget(l,i,x);
    layout->addWidget(wName2,i,x+1,1,6);
    i++;
    l=new QLabel("Nachname");
    layout->addWidget(l,i,x);
    layout->addWidget(wName1,i,x+1,1,6);
    i++;
  }
  else
  {
    l=new QLabel("Name");
    layout->addWidget(l,i,x);
    layout->addWidget(wName1,i,x+1,1,6);
    i++;
  }
  l=new QLabel("Strasse");
  layout->addWidget(l,i,x);
  layout->addWidget(wStrasse,i,x+1,1,6);
  i++;
  l=new QLabel("PLZ/Ort");
  layout->addWidget(l,i,x);
  layout->addWidget(wPlz,i,x+1,1,1);
  layout->addWidget(wOrt,i,x+2,1,6);
  i++;
  l=new QLabel("Land");
  layout->addWidget(l,i,x);
  layout->addWidget(wLand,i,x+1,1,6);
  i++;
  l=new QLabel("Email");
  layout->addWidget(l,i,x);
  layout->addWidget(wMail,i,x+1,1,6);
}

void WAdresse::clear()
{
  wName1->setText("");
  if (wName2!=NULL) wName2->setText("");
  wStrasse->setText("");
  wPlz->setText("");
  wOrt->setText("");
  wLand->setText("");
  wMail->setText("");
}

void WAdresse::setEnabled(bool flag_enable)
{
  wName1->setEnabled(flag_enable);
  if (wName2!=NULL) wName2->setEnabled(flag_enable);
  wStrasse->setEnabled(flag_enable);
  wPlz->setEnabled(flag_enable);
  wOrt->setEnabled(flag_enable);
  wLand->setEnabled(flag_enable);
  wMail->setEnabled(flag_enable);
}

void WAdresse::pFelder()
{
  sName1  =wName1  ->text().replace("'","`").simplified();
  if (wName2==NULL)
    sName2="";
  else
    sName2=wName2  ->text().replace("'","`").simplified();
  sStrasse=wStrasse->text().replace("'","`").simplified();
  sPlz    =wPlz    ->text().replace("'","`").simplified();
  sOrt    =wOrt    ->text().replace("'","`").simplified();
  sLand   =wLand   ->text().replace("'","`").simplified();
  sMail   =wMail   ->text().replace("'","`").simplified();
}

bool WAdresse::isEmpty()
{
  pFelder();
  if (sName1.length()>0 || sName2.length()>0 ||
      sStrasse.length()>0 || sPlz.length()>0 ||
      sOrt.length()>0 || sLand.length()>0 || sMail.length()>0)
      return(false);
  else
      return(true);
}

void WAdresse::write(QString wKenz, QString wKey)
{
  QSqlQuery query;
  QString   sSuchName;

  if (isEmpty()) { del(wKenz, wKey); return; }
  sSuchName=SuchName(sName1,sName2);
  query.exec("UPDATE adresse SET suchname='" + sSuchName +
             "',name1='" + sName1 + "',name2='" + sName2 +
             "',strasse='" + sStrasse + "',plz='" + sPlz + "',ort='" + sOrt +
             "',land='" + sLand + "',mail='" + sMail +
             "' WHERE art='" + wKenz + "' AND key='" + wKey + "'");
  if (query.numRowsAffected()<1)
  {
    query.exec("INSERT INTO adresse (art,key,suchname,name1,name2,strasse,plz,ort,land,mail) VALUES ('" +
        wKenz + "','" + wKey + "','" + sSuchName + "','" + sName1 + "','" +
        sName2 + "','" + sStrasse + "','" + sPlz + "','" + sOrt + "','" +
        sLand + "','" + sMail + "')");
  }
}

void WAdresse::del(QString wKenz, QString wKey)
{
  QSqlQuery query;

  query.exec("DELETE FROM adresse WHERE art='" + wKenz +
              "' AND key='" + wKey + "'");
}

void WAdresse::read(QString wKenz, QString wKey)
{
  QSqlQuery query;

  query.exec("SELECT name1,name2,strasse,plz,ort,land,mail from adresse WHERE art='" +
              wKenz + "' AND key='" + wKey + "'");
  if (query.next())
  {
    wName1->setText(query.value(0).toString());
    if (wName2!=NULL)
       wName2->setText(query.value(1).toString());
    wStrasse->setText(query.value(2).toString());
    wPlz->setText(query.value(3).toString());
    wOrt->setText(query.value(4).toString());
    wLand->setText(query.value(5).toString());
    wMail->setText(query.value(6).toString());
    query.finish();
  }
}
