#include "wbank.h"

WBank::WBank(QWidget *parent)
{
  wParent=parent;

  wKontoInh =new QLineEdit(parent);  wKontoInh->setFixedSize(230,25);
  wKontoNr  =new QLineEdit(parent);   wKontoNr->setFixedSize(110,25);
  wKontoBlz =new QLineEdit(parent);  wKontoBlz->setFixedSize(75,25);
  wKontoBank=new QLineEdit(parent); wKontoBank->setFixedSize(230,25);
  wKontoBic =new QLineEdit(parent);  wKontoBic->setFixedSize(130,25);
  wKontoIban=new QLineEdit(parent); wKontoIban->setFixedSize(330,25);

  wKontoInh->setMaxLength(27);
  wKontoNr->setMaxLength(12);
  wKontoBlz->setMaxLength(8);
  wKontoBank->setMaxLength(27);
  wKontoBic->setMaxLength(12);
  wKontoIban->setMaxLength(35);
}

WBank::~WBank()
{
  delete(wKontoInh);
  delete(wKontoNr);
  delete(wKontoBlz);
  delete(wKontoBank);
  delete(wKontoBic);
  delete(wKontoIban);
}

QLineEdit *WBank::KontoInh() { return(wKontoInh); }
QLineEdit *WBank::KontoNr() { return(wKontoNr); }
QLineEdit *WBank::KontoBlz() { return(wKontoBlz); }
QLineEdit *WBank::KontoBank() { return(wKontoBank); }
QLineEdit *WBank::KontoBic() { return(wKontoBic); }
QLineEdit *WBank::KontoIban() { return(wKontoIban); }

void WBank::FuellLayout(QGridLayout *layout, int y, int x)
{
  QLabel *l;

  l=new QLabel("Konto Inhaber",wParent);
  layout->addWidget(l,y,x);
  layout->addWidget(wKontoInh,y,x+1,1,2);
  l=new QLabel("Konto Nr./BLZ.",wParent);
  layout->addWidget(l,y+1,x);
  layout->addWidget(wKontoNr,y+1,x+1);
  layout->addWidget(wKontoBlz,y+1,x+2);
  l=new QLabel("Bank",wParent);
  layout->addWidget(l,y+2,x);
  layout->addWidget(wKontoBank,y+2,x+1,1,2);
  l=new QLabel("BIC",wParent);
  layout->addWidget(l,y+3,x);
  layout->addWidget(wKontoBic,y+3,x+1);
  l=new QLabel("IBAN",wParent);
  layout->addWidget(l,y+4,x);
  layout->addWidget(wKontoIban,y+4,x+1,1,3);

}

void WBank::clear()
{
  wKontoInh->setText("");
  wKontoNr->setText("");
  wKontoBlz->setText("");
  wKontoBank->setText("");
  wKontoBic->setText("");
  wKontoIban->setText("");
}

void WBank::setEnabled(bool flag_enable)
{
  wKontoInh->setEnabled(flag_enable);
  wKontoNr->setEnabled(flag_enable);
  wKontoBlz->setEnabled(flag_enable);
  wKontoBank->setEnabled(flag_enable);
  wKontoBic->setEnabled(flag_enable);
  wKontoIban->setEnabled(flag_enable);
}

void WBank::pFelder()
{
  sKontoInh=wKontoInh->text().replace("'","`").simplified();
  sKontoNr=wKontoNr->text().replace("'","`").simplified();
  sKontoBlz=wKontoBlz->text().replace("'","`").simplified();
  sKontoBank=wKontoBank->text().replace("'","`").simplified();
  sKontoBic=wKontoBic->text().replace("'","`").simplified();
  sKontoIban=wKontoIban->text().replace("'","`").simplified();
}

bool WBank::isEmpty()
{
  pFelder();

  if (sKontoInh.length()>0 || sKontoNr.length()>0 ||
      sKontoBlz.length()>0 || sKontoBank.length()>0 ||
      sKontoBic.length()>0 || sKontoIban.length()>0)
      return(false);
  else
      return(true);
}

void WBank::del(QString wKenz, QString wKey)
{
  QSqlQuery query;

  query.exec("DELETE FROM bankverbindung WHERE art='" + wKenz +
             "' AND key='" + wKey + "'");
}

void WBank::write(QString wKenz, QString wKey)
{
  QSqlQuery query;

  if (isEmpty()) { del(wKenz, wKey); return; }
  query.exec("UPDATE bankverbindung SET inhaber='" + sKontoInh +
             "',nummer='" +sKontoNr + "',blz='" + sKontoBlz +
             "',bank='" + sKontoBank + "',bic='" + sKontoBic +
             "',iban='" + sKontoIban + "' WHERE art='" + wKenz +
             "' AND key='" + wKey + "'");
  if (query.numRowsAffected()<1)
  {
    query.exec("INSERT INTO bankverbindung (art,key,inhaber,nummer,blz,bank,bic,iban) VALUES ('" +
              wKenz + "','" + wKey + "','" + sKontoInh + "','" +
              sKontoNr + "','" + sKontoBlz + "','" + sKontoBank + "','" +
              sKontoBic + "','" + sKontoIban + "')");
  }
}

void WBank::read(QString wKenz, QString wKey)
{
  QSqlQuery query;

  query.exec("SELECT inhaber,nummer,blz,bank,bic,iban FROM bankverbindung WHERE art='" +
             wKenz + "' AND key='" + wKey + "'");
  if (query.next())
  {
    wKontoInh->setText(query.value(0).toString());
    wKontoNr->setText(query.value(1).toString());
    wKontoBlz->setText(query.value(2).toString());
    wKontoBank->setText(query.value(3).toString());
    wKontoBic->setText(query.value(4).toString());
    wKontoIban->setText(query.value(5).toString());
    query.finish();
  }
}

