#include <QtGui>
#include <QSqlQuery>

#include "utils.h"
#include "wmitglied.h"
#include "midsuche.h"

WMitglied::WMitglied(bool flag_anlegen, QWidget *parent) : QLineEdit(parent)
{
  fAnlegen=flag_anlegen;
  setFixedSize(95,25);
  setAlignment(Qt::AlignVCenter | Qt::AlignRight);
  connect(this,SIGNAL(returnPressed()),this,SLOT(pEnter()));
  connect(this,SIGNAL(editingFinished()),this,SLOT(pEditingFinished()));
}

void WMitglied::pEditingFinished()
{
    emit(finished());
}

void WMitglied::pEnter()
{
  QString s=text().simplified().toUpper();
  int     r;
  if (s.left(1)=="P" || s.left(1)=="N" || s.left(1) == "M" || s.right(1)=="?")
  {
    MIDSuche wDiag(fAnlegen);
    r=wDiag.exec(s);
    if (r==QDialog::Accepted)
    {
      setText(QString::number(wDiag.auswahl()));
    }
    else
      setFocus();
  }
  else if (s.left(1)=="N")
  {
    setFocus();
  }
  else
    emit(finished());
}

int WMitglied::getInt()
{
  return(text().simplified().toInt());
}

QString WMitglied::getKey()
{
  QString s;
  int     i;
  i=getInt();
  if (i<1) return("");
  s=s.sprintf("%08i",i);
  return(s);
}
