#include <QtSql>
#include <QtGui>

#include "zahlerst.h"
#include "utils.h"

ZahlungErst::ZahlungErst(QWidget *parent) : QDialog(parent)
{
  QVBoxLayout *topLayout;
  QGridLayout *mainLayout;
  QHBoxLayout *buttonLayout;
  QLabel      *l;
  int y;

  setWindowTitle("Erstellung Zahlungsdaten");
  topLayout=new QVBoxLayout();
  mainLayout=new QGridLayout();
  buttonLayout=new QHBoxLayout();

  wVal.setRange(1,999);

  topLayout->addLayout(mainLayout);
  topLayout->addLayout(buttonLayout);

  wTageLast = new QLineEdit(this);
  wTageLast->setFixedSize(50,25);
  wTageLast->setValidator(new QIntValidator(1,99,this));
  wTageLast->setAlignment(Qt::AlignVCenter|Qt::AlignRight);
  wTageLast->setText("7");
  wTageLast->setValidator(&wVal);
  wTageMahn1 = new QLineEdit(this);
  wTageMahn1->setFixedSize(50,25);
  wTageMahn1->setValidator(new QIntValidator(1,99,this));
  wTageMahn1->setAlignment(Qt::AlignVCenter|Qt::AlignRight);
  wTageMahn1->setText("7");
  wTageMahn1->setValidator(&wVal);
  wTageMahn2 = new QLineEdit(this);
  wTageMahn2->setFixedSize(50,25);
  wTageMahn2->setValidator(new QIntValidator(1,99,this));
  wTageMahn2->setAlignment(Qt::AlignVCenter|Qt::AlignRight);
  wTageMahn2->setText("7");
  wTageMahn2->setValidator(&wVal);
  wTageMahn3 = new QLineEdit(this);
  wTageMahn3->setFixedSize(50,25);
  wTageMahn3->setValidator(new QIntValidator(1,99,this));
  wTageMahn3->setAlignment(Qt::AlignVCenter|Qt::AlignRight);
  wTageMahn3->setText("7");
  wTageMahn3->setValidator(&wVal);

  wCheckRech=new QCheckBox("Vorkasse",this);
  wTextRechM=new QLineEdit(this);
  wTextRechM->setFixedSize(150,25);
  wTextRechB=new QLineEdit(this);
  wTextRechB->setFixedSize(150,25);
  wCheckRechNeu=new QCheckBox("Vorkasse Neumitglied",this);
  wTextRechNeuM=new QLineEdit(this);
  wTextRechNeuM->setFixedSize(150,25);
  wTextRechNeuB=new QLineEdit(this);
  wTextRechNeuB->setFixedSize(150,25);
  wCheckLast=new QCheckBox("Lastschrift",this);
  wTextLastM=new QLineEdit(this);
  wTextLastM->setFixedSize(150,25);
  wTextLastB=new QLineEdit(this);
  wTextLastB->setFixedSize(150,25);
  wCheckLastNeu=new QCheckBox("Lastschrift Neumitglied",this);
  wTextLastNeuM=new QLineEdit(this);
  wTextLastNeuM->setFixedSize(150,25);
  wTextLastNeuB=new QLineEdit(this);
  wTextLastNeuB->setFixedSize(150,25);
  wCheckDtaus=new QCheckBox("DTAUS-Datei",this);
  lKontoDtaus=new QLabel(this);
  lKontoDtaus->setFixedSize(300,25);
  wKontoDtaus=new WKonto(lKontoDtaus,true,this);
  wCheckPlatz=new QCheckBox("Geplatzte Lastschrift",this);
  wTextPlatzM=new QLineEdit(this);
  wTextPlatzM->setFixedSize(150,25);
  wTextPlatzB=new QLineEdit(this);
  wTextPlatzB->setFixedSize(150,25);
  wCheckMahn1=new QCheckBox("1. Mahnung",this);
  wTextMahn1M=new QLineEdit(this);
  wTextMahn1M->setFixedSize(150,25);
  wTextMahn1B=new QLineEdit(this);
  wTextMahn1B->setFixedSize(150,25);
  wCheckMahn2=new QCheckBox("2. Mahnung",this);
  wTextMahn2M=new QLineEdit(this);
  wTextMahn2M->setFixedSize(150,25);
  wTextMahn2B=new QLineEdit(this);
  wTextMahn2B->setFixedSize(150,25);
  wCheckMahn3=new QCheckBox("3. Mahnung",this);
  wTextMahn3M=new QLineEdit(this);
  wTextMahn3M->setFixedSize(150,25);
  wTextMahn3B=new QLineEdit(this);
  wTextMahn3B->setFixedSize(150,25);

  pReadParam();

  y=1;
  l=new QLabel("Zeitabstnde");
  mainLayout->addWidget(l,y,1);
  y++;
  l=new QLabel("Rechnung->Lastschrift");
  mainLayout->addWidget(l,y,1);
  mainLayout->addWidget(wTageLast,y,2);
  y++;
  l=new QLabel("Rechnung->1.Mahnung");
  mainLayout->addWidget(l,y,1);
  mainLayout->addWidget(wTageMahn1,y,2);
  y++;
  l=new QLabel("1.Mahnung->2.Mahnung");
  mainLayout->addWidget(l,y,1);
  mainLayout->addWidget(wTageMahn2,y,2);
  y++;
  l=new QLabel("2.Mahnung->3.Mahnung");
  mainLayout->addWidget(l,y,1);
  mainLayout->addWidget(wTageMahn3,y,2);
  y++;
  l=new QLabel("Textbausteine:");
  mainLayout->addWidget(l,y,1);
  l=new QLabel("Email");
  mainLayout->addWidget(l,y,2);
  l=new QLabel("Brief");
  mainLayout->addWidget(l,y,3);
  y++;
  mainLayout->addWidget(wCheckRech,y,1);
  mainLayout->addWidget(wTextRechM,y,2);
  mainLayout->addWidget(wTextRechB,y,3);
  y++;
  mainLayout->addWidget(wCheckRechNeu,y,1);
  mainLayout->addWidget(wTextRechNeuM,y,2);
  mainLayout->addWidget(wTextRechNeuB,y,3);
  y++;
  mainLayout->addWidget(wCheckLast,y,1);
  mainLayout->addWidget(wTextLastM,y,2);
  mainLayout->addWidget(wTextLastB,y,3);
  y++;
  mainLayout->addWidget(wCheckLastNeu,y,1);
  mainLayout->addWidget(wTextLastNeuM,y,2);
  mainLayout->addWidget(wTextLastNeuB,y,3);
  y++;
  mainLayout->addWidget(wCheckDtaus,y,1);
  mainLayout->addWidget(wKontoDtaus,y,2);
  mainLayout->addWidget(lKontoDtaus,y,3,1,2);
  y++;
  mainLayout->addWidget(wCheckPlatz,y,1);
  mainLayout->addWidget(wTextPlatzM,y,2);
  mainLayout->addWidget(wTextPlatzB,y,3);
  y++;
  mainLayout->addWidget(wCheckMahn1,y,1);
  mainLayout->addWidget(wTextMahn1M,y,2);
  mainLayout->addWidget(wTextMahn1B,y,3);
  y++;
  mainLayout->addWidget(wCheckMahn2,y,1);
  mainLayout->addWidget(wTextMahn2M,y,2);
  mainLayout->addWidget(wTextMahn2B,y,3);
  y++;
  mainLayout->addWidget(wCheckMahn3,y,1);
  mainLayout->addWidget(wTextMahn3M,y,2);
  mainLayout->addWidget(wTextMahn3B,y,3);
  y++;

  mainLayout->setColumnStretch(4,1);

  wCheckRech->setCheckState(Qt::Checked);
  wCheckRechNeu->setCheckState(Qt::Checked);
  wCheckLast->setCheckState(Qt::Checked);
  wCheckLastNeu->setCheckState(Qt::Checked);
  wCheckDtaus->setCheckState(Qt::Checked);
  wCheckPlatz->setCheckState(Qt::Checked);
  wCheckMahn1->setCheckState(Qt::Checked);
  wCheckMahn2->setCheckState(Qt::Checked);
  wCheckMahn3->setCheckState(Qt::Checked);

  bOk=new QPushButton("&Ok",this);
  bCancel=new QPushButton("&Abbruch",this);
  lMidDis=new QLabel();
  lMidDis->setFixedSize(150,25);
  buttonLayout->addWidget(bOk);
  buttonLayout->addWidget(bCancel);
  buttonLayout->addWidget(lMidDis);
  buttonLayout->addStretch(1);

  setLayout(topLayout);

  connect(bOk,SIGNAL(clicked()),this,SLOT(pLauf()));
  connect(bCancel,SIGNAL(clicked()),this,SLOT(reject()));
  connect(wCheckRech,SIGNAL(stateChanged(int)),this,SLOT(pStateRech(int)));
  connect(wCheckRechNeu,SIGNAL(stateChanged(int)),this,SLOT(pStateRechNeu(int)));
  connect(wCheckLast,SIGNAL(stateChanged(int)),this,SLOT(pStateLast(int)));
  connect(wCheckLastNeu,SIGNAL(stateChanged(int)),this,SLOT(pStateLastNeu(int)));
  connect(wCheckPlatz,SIGNAL(stateChanged(int)),this,SLOT(pStatePlatz(int)));
  connect(wCheckMahn1,SIGNAL(stateChanged(int)),this,SLOT(pStateMahn1(int)));
  connect(wCheckMahn2,SIGNAL(stateChanged(int)),this,SLOT(pStateMahn2(int)));
  connect(wCheckMahn3,SIGNAL(stateChanged(int)),this,SLOT(pStateMahn3(int)));
}

ZahlungErst::~ZahlungErst()
{
  delete wTageLast;
  delete wTageMahn1;
  delete wTageMahn2;
  delete wTageMahn3;
  delete wTextRechM;
  delete wTextRechB;
  delete wTextRechNeuM;
  delete wTextRechNeuB;
  delete wTextLastM;
  delete wTextLastB;
  delete wTextLastNeuM;
  delete wTextLastNeuB;
  delete wTextPlatzM;
  delete wTextPlatzB;
  delete wTextMahn1M;
  delete wTextMahn1B;
  delete wTextMahn2M;
  delete wTextMahn2B;
  delete wTextMahn3M;
  delete wTextMahn3B;
  delete wCheckRech;
  delete wCheckRechNeu;
  delete wCheckLast;
  delete wCheckLastNeu;
  delete wCheckPlatz;
  delete wCheckMahn1;
  delete wCheckMahn2;
  delete wCheckMahn3;
  delete wCheckDtaus;
  delete bOk;
  delete bCancel;
  return;
}

void ZahlungErst::pStateRech(int wState)
{
  wTextRechM->setEnabled(wState==Qt::Checked);
  wTextRechB->setEnabled(wState==Qt::Checked);
}
void ZahlungErst::pStateRechNeu(int wState)
{
  wTextRechNeuM->setEnabled(wState==Qt::Checked);
  wTextRechNeuB->setEnabled(wState==Qt::Checked);
}
void ZahlungErst::pStateLast(int wState)
{
  wTextLastM->setEnabled(wState==Qt::Checked);
  wTextLastB->setEnabled(wState==Qt::Checked);
}
void ZahlungErst::pStateLastNeu(int wState)
{
  wTextLastNeuM->setEnabled(wState==Qt::Checked);
  wTextLastNeuB->setEnabled(wState==Qt::Checked);
}
void ZahlungErst::pStatePlatz(int wState)
{
  wTextPlatzM->setEnabled(wState==Qt::Checked);
  wTextPlatzB->setEnabled(wState==Qt::Checked);
}
void ZahlungErst::pStateMahn1(int wState)
{
  wTextMahn1M->setEnabled(wState==Qt::Checked);
  wTextMahn1B->setEnabled(wState==Qt::Checked);
}
void ZahlungErst::pStateMahn2(int wState)
{
  wTextMahn2M->setEnabled(wState==Qt::Checked);
  wTextMahn2B->setEnabled(wState==Qt::Checked);
}
void ZahlungErst::pStateMahn3(int wState)
{
  wTextMahn3M->setEnabled(wState==Qt::Checked);
  wTextMahn3B->setEnabled(wState==Qt::Checked);
}

void ZahlungErst::pFelder()
{
  fRech=fRechNeu=fLast=fLastNeu=fPlatz=fMahn1=fMahn2=fMahn3=fDtaus=false;
  fRechM=fRechNeuM=fLastM=fLastNeuM=fPlatzM=fMahn1M=fMahn2M=fMahn3M=false;
  fRechB=fRechNeuB=fLastB=fLastNeuB=fPlatzB=fMahn1B=fMahn2B=fMahn3B=false;
  iTageLast=wTageLast->text().toInt();
  if (iTageLast<1||iTageLast>999) iTageLast=7;
  iTageMahn1=wTageMahn1->text().toInt();
  if (iTageMahn1<1||iTageMahn1>999) iTageMahn1=7;
  iTageMahn2=wTageMahn2->text().toInt();
  if (iTageMahn2<1||iTageMahn2>999) iTageMahn2=7;
  iTageMahn3=wTageMahn3->text().toInt();
  if (iTageMahn3<1||iTageMahn3>999) iTageMahn3=7;
  sTextRechM=wTextRechM->text().toUpper().simplified().replace("'","`");
  sTextRechB=wTextRechB->text().toUpper().simplified().replace("'","`");
  sTextRechNeuM=wTextRechNeuM->text().toUpper().simplified().replace("'","`");
  sTextRechNeuB=wTextRechNeuB->text().toUpper().simplified().replace("'","`");
  sTextLastM=wTextLastM->text().toUpper().simplified().replace("'","`");
  sTextLastB=wTextLastB->text().toUpper().simplified().replace("'","`");
  sTextLastNeuM=wTextLastNeuM->text().toUpper().simplified().replace("'","`");
  sTextLastNeuB=wTextLastNeuB->text().toUpper().simplified().replace("'","`");
  sTextPlatzM=wTextPlatzM->text().toUpper().simplified().replace("'","`");
  sTextPlatzB=wTextPlatzB->text().toUpper().simplified().replace("'","`");
  sTextMahn1M=wTextMahn1M->text().toUpper().simplified().replace("'","`");
  sTextMahn1B=wTextMahn1B->text().toUpper().simplified().replace("'","`");
  sTextMahn2M=wTextMahn2M->text().toUpper().simplified().replace("'","`");
  sTextMahn2B=wTextMahn2B->text().toUpper().simplified().replace("'","`");
  sTextMahn3M=wTextMahn3M->text().toUpper().simplified().replace("'","`");
  sTextMahn3B=wTextMahn3B->text().toUpper().simplified().replace("'","`");
  sKontoDtaus=wKontoDtaus->text().toUpper().simplified().replace("'","`");
  if (wCheckDtaus->checkState()==Qt::Checked)
     fDtaus=true;
  if (wCheckRech->checkState()==Qt::Checked && sTextRechM.length()>0)
     fRechM=true;
  if (wCheckRech->checkState()==Qt::Checked && sTextRechB.length()>0)
     fRechB=true;
  if (wCheckRechNeu->checkState()==Qt::Checked && sTextRechNeuM.length()>0)
     fRechNeuM=true;
  if (wCheckRechNeu->checkState()==Qt::Checked && sTextRechNeuB.length()>0)
     fRechNeuB=true;
  if (wCheckLast->checkState()==Qt::Checked && sTextLastM.length()>0)
     fLastM=true;
  if (wCheckLast->checkState()==Qt::Checked && sTextLastB.length()>0)
     fLastB=true;
  if (wCheckLastNeu->checkState()==Qt::Checked && sTextLastNeuM.length()>0)
     fLastNeuM=true;
  if (wCheckLastNeu->checkState()==Qt::Checked && sTextLastNeuB.length()>0)
     fLastNeuB=true;
  if (wCheckPlatz->checkState()==Qt::Checked && sTextPlatzM.length()>0)
     fPlatzM=true;
  if (wCheckPlatz->checkState()==Qt::Checked && sTextPlatzB.length()>0)
     fPlatzB=true;
  if (wCheckMahn1->checkState()==Qt::Checked && sTextMahn1M.length()>0)
     fMahn1M=true;
  if (wCheckMahn1->checkState()==Qt::Checked && sTextMahn1B.length()>0)
     fMahn1B=true;
  if (wCheckMahn2->checkState()==Qt::Checked && sTextMahn2M.length()>0)
     fMahn2M=true;
  if (wCheckMahn2->checkState()==Qt::Checked && sTextMahn2B.length()>0)
     fMahn2B=true;
  if (wCheckMahn3->checkState()==Qt::Checked && sTextMahn3M.length()>0)
     fMahn3M=true;
  if (wCheckMahn3->checkState()==Qt::Checked && sTextMahn3B.length()>0)
     fMahn3B=true;
  fRech    = fRechM    | fRechB;
  fRechNeu = fRechNeuM | fRechNeuB;
  fLast    = fLastM    | fLastB;
  fLastNeu = fLastNeuM | fLastNeuB;
  fPlatz   = fPlatzM   | fPlatzB;
  fMahn1   = fMahn1M   | fMahn1B;
  fMahn2   = fMahn2M   | fMahn2B;
  fMahn3   = fMahn3M   | fMahn3B;
}

void ZahlungErst::pSaveParam()
{
  QSqlQuery query;
  query.exec("START TRANSACTION");
  query.exec("DELETE FROM parameter WHERE key>='Zahlungen/' AND key<='Zahlungen/zzz'");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TageLast','" +
             QString::number(iTageLast) + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TageMahn1','" +
             QString::number(iTageMahn1) + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TageMahn2','" +
             QString::number(iTageMahn2) + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TageMahn3','" +
             QString::number(iTageMahn3) + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextRechM','" +
             sTextRechM + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextRechB','" +
             sTextRechB + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextRechNeuM','" +
             sTextRechNeuM + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextRechNeuB','" +
             sTextRechNeuB + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextLastM','" +
             sTextLastM + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextLastB','" +
             sTextLastB + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextLastNeuM','" +
             sTextLastNeuM + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextLastNeuB','" +
             sTextLastNeuB + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextPlatzM','" +
             sTextPlatzM + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextPlatzB','" +
             sTextPlatzB + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextMahn1M','" +
             sTextMahn1M + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextMahn1B','" +
             sTextMahn1B + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextMahn2M','" +
             sTextMahn2M + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextMahn2B','" +
             sTextMahn2B + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextMahn3M','" +
             sTextMahn3M + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/TextMahn3B','" +
             sTextMahn3B + "')");
  query.exec("INSERT INTO parameter (key,wert) VALUES ('Zahlungen/KontoDtaus','" +
             sKontoDtaus + "')");
  query.exec("COMMIT TRANSACTION");
}

void ZahlungErst::pReadParam()
{
  QSqlQuery   query;
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TageLast'");
  if (query.next()) wTageLast->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TageMahn1'");
  if (query.next()) wTageMahn1->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TageMahn2'");
  if (query.next()) wTageMahn2->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TageMahn3'");
  if (query.next()) wTageMahn3->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextRechM'");
  if (query.next()) wTextRechM->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextRechB'");
  if (query.next()) wTextRechB->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextRechNeuM'");
  if (query.next()) wTextRechNeuM->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextRechNeuB'");
  if (query.next()) wTextRechNeuB->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextLastM'");
  if (query.next()) wTextLastM->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextLastB'");
  if (query.next()) wTextLastB->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextLastNeuM'");
  if (query.next()) wTextLastNeuM->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextLastNeuB'");
  if (query.next()) wTextLastNeuB->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextPlatzM'");
  if (query.next()) wTextPlatzM->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextPlatzB'");
  if (query.next()) wTextPlatzB->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextMahn1M'");
  if (query.next()) wTextMahn1M->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextMahn1B'");
  if (query.next()) wTextMahn1B->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextMahn2M'");
  if (query.next()) wTextMahn2M->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextMahn2B'");
  if (query.next()) wTextMahn2B->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextMahn3M'");
  if (query.next()) wTextMahn3M->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/TextMahn3B'");
  if (query.next()) wTextMahn3B->setText(query.value(0).toString());
  query.exec("SELECT wert FROM parameter WHERE key='Zahlungen/KontoDtaus'");
  if (query.next()) wKontoDtaus->setText(query.value(0).toString());
}

void ZahlungErst::pLauf()
{
  QSqlQuery query,query2;
  QDate     wDatumBis,wDatumAkt,wDatumVon,wGjVon;
  bool      flag_lastschrift,flag_mail,flag_erst;
  QString   cMid;
  QString   s,sArt,sForm,sBausteinM,sBausteinB,sStatusNeu;
  int       iTage,wAnzMon;
  qint64    wCent;
  int       wAnzRechM,wAnzRechB,wAnzRechNeuM,wAnzRechNeuB;
  int       wAnzLastM,wAnzLastB,wAnzLastNeuM,wAnzLastNeuB;
  int       wAnzDtaus,wAnzPlatzM,wAnzPlatzB,wAnzMahn1M,wAnzMahn1B;
  int       wAnzMahn2M,wAnzMahn2B,wAnzMahn3M,wAnzMahn3B;
  qint64    wSumRech,wSumRechNeu,wSumLast,wSumLastNeu,wSumDtaus;
  qint64    wSumPlatz,wSumMahn1,wSumMahn2,wSumMahn3;

  pFelder();
  wGjVon=UtilGJVon();
  wDatumBis=wGjVon.addYears(1).addDays(-1);
  wDatumAkt=QDate::currentDate();
  pSaveParam();

  wAnzRechM=wAnzRechB=wAnzRechNeuM=wAnzRechNeuB=0;
  wAnzLastM=wAnzLastB=wAnzLastNeuM=wAnzLastNeuB=0;
  wAnzDtaus=wAnzPlatzM=wAnzPlatzB=wAnzMahn1M=wAnzMahn1B=0;
  wAnzMahn2M=wAnzMahn2B=wAnzMahn3M=wAnzMahn3B=0;
  wSumRech=wSumRechNeu=wSumLast=wSumLastNeu=wSumDtaus=0;
  wSumPlatz=wSumMahn1=wSumMahn2=wSumMahn3=0;
  flag_erst=false;
  query.exec("DELETE FROM parameter WHERE key = 'Status/Zahlungen'");
  query.exec("DELETE FROM zahllauf");
  query.exec("SELECT mid,zahlart,beitrag,zahlstatus,statusdatum,bezahlt,eintritt FROM mitglied WHERE mid<'1000000' AND austritt > '" +
              wDatumAkt.toString("yyyy-MM-dd") + "' AND bezahlt < '" +
              wDatumBis.toString("yyyy-MM-dd") + "'");
  while(query.next())
  {
    flag_lastschrift=flag_mail=false;
    cMid=cMid.sprintf("%08i",query.value(0).toInt());
    lMidDis->setText(query.value(0).toString());
    QCoreApplication::processEvents();

    query2.exec("SELECT mail FROM adresse WHERE art='M' AND key='" + cMid + "'");
    if (query2.next())
    {
       if (query2.value(0).toString().length()>0) flag_mail=true;
       query2.finish();
    }
    if (query.value(1).toString() == "L") flag_lastschrift=true;
    // Art: "!": Nichts
    //      "D": DTAUS-Datei
    //      "L": Lastschrift-Benachrichtigung
    //      "l": Lastschrift-Benachrichtigung Neumitglied
    //      "R": Rechnung
    //      "r": Rechnung Neumitglied
    //      "G": Geplatzte Lastschrift
    //      "1": 1. Mahnung
    //      "2": 2. Mahnung
    //      "3": 3. Mahnung
    sArt="!";
    if (query.value(3).toString() == "N")
    {
      if (flag_lastschrift)
      {
        if (!fLastNeu) continue;
        if (!flag_mail && !fLastNeuB) continue;
        sArt="l";
        sBausteinM=sTextLastNeuM;
        sBausteinB=sTextLastNeuB;
      }
      else
      {
        if (!fRechNeu) continue;
        if (!flag_mail && !fRechNeuB) continue;
        sArt="r";
        sBausteinM=sTextRechNeuM;
        sBausteinB=sTextRechNeuB;
      }
      sStatusNeu="R";
      iTage=0;
    }
    else if (query.value(3).toString() == "R")
    {
      if (flag_lastschrift)
      {
        if (!fDtaus) continue;
        sArt="D";
        sBausteinM=sKontoDtaus;
        sBausteinB="";
        sStatusNeu="L";
        iTage=iTageLast;
      }
      else
      {
        if (!fMahn1) continue;
        if (!flag_mail && !fMahn1B) continue;
        sArt="1";
        sBausteinM=sTextMahn1M;
        sBausteinB=sTextMahn1B;
        sStatusNeu="1";
        iTage=iTageMahn1;
      }
    }
    else if (query.value(3).toString() == "1")
    {
      if (!fMahn2) continue;
      if (!flag_mail && !fMahn2B) continue;
      sArt="2";
      sBausteinM=sTextMahn2M;
      sBausteinB=sTextMahn2B;
      sStatusNeu="2";
      iTage=iTageMahn2;
    }
    else if (query.value(3).toString() == "2")
    {
      if (!fMahn2) continue;
      if (!flag_mail && !fMahn2B) continue;
      sArt="3";
      sBausteinM=sTextMahn3M;
      sBausteinB=sTextMahn3B;
      sStatusNeu="3";
      iTage=iTageMahn3;
    }
    else if (query.value(3).toString() < "!")
    {
      if (flag_lastschrift)
      {
        if (!fLast) continue;
        if (!flag_mail && !fLastB) continue;
        sArt="L";
        sBausteinM=sTextLastM;
        sBausteinB=sTextLastB;
      }
      else
      {
        if (query.value(1).toString() == "G")
        {
          if (!fPlatz) continue;
          if (!flag_mail && !fPlatzB) continue;
          sArt="G";
          sBausteinM=sTextPlatzM;
          sBausteinB=sTextPlatzB;
        }
        else
        {
          if (!fRech) continue;
          if (!flag_mail && !fRechB) continue;
          sArt="R";
          sBausteinM=sTextRechM;
          sBausteinB=sTextRechB;
        }
      }
      sStatusNeu="R";
      iTage=0;
    }
    else
      continue;
    if (sArt=="!") continue;
    if (query.value(4).toDate().daysTo(wDatumAkt) < iTage) continue;
    if (!flag_mail || sBausteinM.length()<1) sForm="B";
    else                                     sForm="M";
    wDatumVon=wGjVon;
    if (wDatumVon<query.value(5).toDate())
       wDatumVon=query.value(5).toDate();
    if (wDatumVon<query.value(6).toDate())
       wDatumVon=query.value(6).toDate();
    wAnzMon=13-wDatumVon.month();
    wCent=query.value(2).toLongLong();
    if (wCent==0) wCent=3600;
    wCent=wCent*wAnzMon/12;
    flag_erst=true;
    query2.exec("INSERT INTO zahllauf (mid,sperren,art,form,manuell,bausteinm,bausteinb,cent,statusneu,done) VALUES ('" +
                query.value(0).toString() + "','N','" +
                sArt                      + "','"     +
                sForm                     + "','N','" +
                sBausteinM                + "','"     +
                sBausteinB                + "','"     +
                QString::number(wCent)    + "','"     +
                sStatusNeu                + "','N')");
    if (query2.numRowsAffected()>0)
    {
      if (sArt=="D")
         { wAnzDtaus++; wSumDtaus+=wCent; }
      else
      {
        if (sForm=="B")
        {
          if      (sArt=="R") { wAnzRechB++;    wSumRech    += wCent; }
          else if (sArt=="r") { wAnzRechNeuB++; wSumRechNeu += wCent; }
          else if (sArt=="L") { wAnzLastB++;    wSumLast    += wCent; }
          else if (sArt=="l") { wAnzLastNeuB++; wSumLastNeu += wCent; }
          else if (sArt=="G") { wAnzPlatzB++;   wSumPlatz   += wCent; }
          else if (sArt=="1") { wAnzMahn1B++;   wSumMahn1   += wCent; }
          else if (sArt=="2") { wAnzMahn2B++;   wSumMahn2   += wCent; }
          else if (sArt=="3") { wAnzMahn3B++;   wSumMahn3   += wCent; }
        }
        else
        {
          if      (sArt=="R") { wAnzRechM++;    wSumRech    += wCent; }
          else if (sArt=="r") { wAnzRechNeuM++; wSumRechNeu += wCent; }
          else if (sArt=="L") { wAnzLastM++;    wSumLast    += wCent; }
          else if (sArt=="l") { wAnzLastNeuM++; wSumLastNeu += wCent; }
          else if (sArt=="G") { wAnzPlatzM++;   wSumPlatz   += wCent; }
          else if (sArt=="1") { wAnzMahn1M++;   wSumMahn1   += wCent; }
          else if (sArt=="2") { wAnzMahn2M++;   wSumMahn2   += wCent; }
          else if (sArt=="3") { wAnzMahn3M++;   wSumMahn3   += wCent; }
        }
      }
    }
  }

  lMidDis->setText("");
  QCoreApplication::processEvents();

  s="";
  if (wAnzDtaus)    s=s+"J";
  else              s=s+"N";
  if (wAnzRechM)    s=s+"J";
  else              s=s+"N";
  if (wAnzRechB)    s=s+"J";
  else              s=s+"N";
  if (wAnzRechNeuM) s=s+"J";
  else              s=s+"N";
  if (wAnzRechNeuB) s=s+"J";
  else              s=s+"N";
  if (wAnzLastM)    s=s+"J";
  else              s=s+"N";
  if (wAnzLastB)    s=s+"J";
  else              s=s+"N";
  if (wAnzLastNeuM) s=s+"J";
  else              s=s+"N";
  if (wAnzLastNeuB) s=s+"J";
  else              s=s+"N";
  if (wAnzPlatzM)   s=s+"J";
  else              s=s+"N";
  if (wAnzPlatzB)   s=s+"J";
  else              s=s+"N";
  if (wAnzMahn1M)   s=s+"J";
  else              s=s+"N";
  if (wAnzMahn1B)   s=s+"J";
  else              s=s+"N";
  if (wAnzMahn2M)   s=s+"J";
  else              s=s+"N";
  if (wAnzMahn2B)   s=s+"J";
  else              s=s+"N";
  if (wAnzMahn3M)   s=s+"J";
  else              s=s+"N";
  if (wAnzMahn3B)   s=s+"J";
  else              s=s+"N";

  if (flag_erst)
    query.exec("INSERT INTO parameter (key,wert) VALUES ('Status/Zahlungen','" +
               s + "')");
  if (flag_erst)
  {
    s="Zahlungen sind erstellt<table>";
    if (wAnzRechB>0 || wAnzRechM>0)
       s=s+sArt.sprintf("<tr><td align=right>%i</td><td>Rechnungen</td><td align=right>%9s</td></tr>",
           wAnzRechB+wAnzRechM,
           QLocale::system().toString((double)wSumRech/(double)100.0l,'f',2).toAscii().data());
    if (wAnzRechNeuB>0 || wAnzRechNeuM>0)
       s=s+sArt.sprintf("<tr><td align=right>%i</td><td>Rechnungen Neumitglieder</td><td align=right>%9s</td></tr>",
           wAnzRechNeuB+wAnzRechNeuM,
           QLocale::system().toString((double)wSumRechNeu/(double)100.0l,'f',2).toAscii().data());
    if (wAnzLastB>0 || wAnzLastM>0)
       s=s+sArt.sprintf("<tr><td align=right>%i</td><td>Lastschriftankndigungen</td><td align=right>%9s</td></tr>",
           wAnzLastB+wAnzLastM,
           QLocale::system().toString((double)wSumLast/(double)100.0l,'f',2).toAscii().data());
    if (wAnzLastNeuB>0 || wAnzLastNeuM>0)
       s=s+sArt.sprintf("<tr><td align=right>%i</td><td>Lastschriftankndigungen Neumitglieder</td><td align=right>%9s</td></tr>",
           wAnzLastNeuB+wAnzLastNeuM,
           QLocale::system().toString((double)wSumLastNeu/(double)100.0l,'f',2).toAscii().data());
    if (wAnzDtaus>0)
       s=s+sArt.sprintf("<tr><td align=right>%i</td><td>Lastschriften</td><td align=right>%9s</td></tr>",
           wAnzDtaus,
           QLocale::system().toString((double)wSumDtaus/(double)100.0l,'f',2).toAscii().data());
    if (wAnzPlatzB>0 || wAnzPlatzM>0)
       s=s+sArt.sprintf("<tr><td align=right>%i</td><td>Lastschriften zurckgegangen</td><td align=right>%9s</td></tr>",
           wAnzPlatzB + wAnzPlatzM,
           QLocale::system().toString((double)wSumPlatz/(double)100.0l,'f',2).toAscii().data());
    if (wAnzMahn1B>0 || wAnzMahn1M>0)
       s=s+sArt.sprintf("<tr><td align=right>%i</td><td>1. Mahnungen</td><td align=right>%9s</td></tr>",
           wAnzMahn1B + wAnzMahn1M,
           QLocale::system().toString((double)wSumMahn1/(double)100.0l,'f',2).toAscii().data());
    if (wAnzMahn2B>0 || wAnzMahn2M>0)
       s=s+sArt.sprintf("<tr><td align=right>%i</td><td>2. Mahnungen</td><td align=right>%9s</td></tr>",
           wAnzMahn2B + wAnzMahn2M,
           QLocale::system().toString((double)wSumMahn2/(double)100.0l,'f',2).toAscii().data());
    if (wAnzMahn3B>0 || wAnzMahn3M>0)
       s=s+sArt.sprintf("<tr><td align=right>%i</td><td>3. Mahnungen</td><td align=right>%9s</td></tr>",
           wAnzMahn3B + wAnzMahn3M,
           QLocale::system().toString((double)wSumMahn3/(double)100.0l,'f',2).toAscii().data());
    s=s+"</table>";
  }
  else
    s="Keine anstehenden Zahlungen gefunden";
  QMessageBox::information(this,"Zahlungen erstellen",s);
  accept();
}
